{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$WARNINGS OFF}
//=============================================================================
//  l̓R|[lg  plShihanEdit
//
//  ݂̓tDatevpeBɑEditStyleɉYearEditɔN܂
//  Nx̐l\āCDateɉĎl܂͔I
//  YearEditɒڒlZbgꍇ́CYearEdit.Text='17'̂悤ɂ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ܂Czz̍ہCȂ闝R낤Ƃɑ㉿߂邱Ƃ֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  plDateEditƓ
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plShihanEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Variants;

type
  //l㉺
  TplShihanEditStyle = (NendoShihanki, NenShihanki, NendoHanki, NenHanki);

  //N̓͌
  TplYeardigitsSet = (yddigit2, yddigit4);

  TplShihanEdit = class;

  TplShihanEditLabel = class(TCustomControl)
  private
    FplDate : TplShihanEdit;
  protected
  public
    property Color;
    property Font;
    property Text;
    procedure Paint; override;
  published
  end;

  TplShihanEditEdit = TMemo;

  TplShihanEdit = class(TCustomControl)
  private
    BeginDate         : TDateTime;
    FDate             : TDateTime;
    FEditStyle        : TplShihanEditStyle;
    FGengoCombo       : TComboBox;
    FShihanCombo      : TComboBox;
    FYearEdit         : TplShihanEditEdit;
    FGengo            : Boolean;
    FBaseDate         : TDateTime;
    FCanEmpty         : Boolean;
    FIsEmpty          : Boolean;
    FAutoSelect       : Boolean;

    FGengoStr         : String;
    FGengoYear        : Integer;
    FGengoYearStr     : String;
    FEditGengo        : Boolean;

    FYear             : Integer;
    FYearStr          : String;
    FYeardigit        : TplYeardigitsSet;

    FFocusedColor    : TColor;
    FDisableFontColor: TColor;
    FDisableColor    : TColor;

    FYearLabel       : TplShihanEditLabel;

    FEnterNext       : Boolean;
    FExitCheck       : Boolean;
    FDisplayError    : Boolean;
    FDropDownKey     : Boolean;
    FDialogCaption   : String;
    FTabStop         : Boolean;
    FColor           : TColor;
    FOnKeyPress      : TKeyPressEvent;
    FOnKeyDown       : TKeyEvent;
    FOnChange        : TNotifyEvent;
    FOnClick         : TNotifyEvent;
    FFocused         : Boolean;
    fgResize         : Boolean;      //TCYϐ
    fgTabStop        : Boolean;

    DefHeightItemHeightCombo : Integer;

    procedure SetDate(const Value: TDateTime);
    procedure SetGengo(const Value: Boolean);
    function GetProperties: Boolean;
    procedure SetEditGengo(const Value: Boolean);
    procedure SetControlResizePosition(EmptyFlag:Boolean=True);
    function GetDateStr(index: Integer): String;
    function GetDateInt(index: Integer): Integer;
    procedure SetControlFocus(AWinControl: TWinControl);
    function GetIsEmpty: Boolean;
    function CheckDateError: Boolean;
    procedure ShowErrorDialog(ERStr: String; AWinControl: TWinControl);
    procedure EditKeyPress(Sender: TObject; var Key: Char);virtual;
    procedure EditKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);virtual;
    procedure EditChange(Sender: TObject); virtual;
    procedure EditClick (Sender: TObject); virtual;    
    procedure GengoDropDown(Sender: TObject);
    procedure EditEnter(Sender: TObject); virtual;
    procedure EditExit(Sender: TObject);
    procedure ComboMouseWheel(Sender: TObject; Shift: TShiftState;
              WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);    
    procedure CreateComboBox(ACombo : TComboBox );
    procedure CreateLabel(ALabel: TplShihanEditLabel);
    procedure CreateEditBox(AMemo: TplShihanEditEdit);
    procedure CMEnabledChanged(var Message: TWMNoParams); message CM_ENABLEDCHANGED;
    procedure CMFontChanged(var Message: TWMNoParams); message CM_FONTCHANGED;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure CMWantSpecialKey(var Msg: TMessage); message CM_WANTSPECIALKEY;
    procedure SetEditColor;
    procedure SetControlTabStop(const Value: Boolean);
    procedure SetControlColor(const Value: TColor);
    procedure SetDisableColor(const Value: TColor);
    procedure SetDisableFontColor(const Value: TColor);
    procedure GengoDrawItem(Control: TWinControl; Index: Integer;
             Rect: TRect; State: TOwnerDrawState);
    procedure SetYeardigit(const Value: TplYeardigitsSet);
    procedure SetEditStyle(const Value: TplShihanEditStyle);
    function GetDate(index : Integer): TDateTime;

{$IFDEF CONDITIONALEXPRESSIONS}
{$IF RTLVersion >= 24.0}
  class var
    FFormatSettings: TFormatSettings;
{$IF RTLVersion >= 26.0}
    MaxEraCount: Integer;
    EraNames: array of string;
    EraYearOffsets: array of Integer;
{$IFEND}
    class constructor Create;
    function FormatDateTime(const Format: string; DateTime: TDateTime): string;
{$IFEND}
{$ENDIF}
  protected
    procedure Loaded; override;
    procedure SetParent(AParent: TWinControl); override;
    function CanResize(var NewWidth, NewHeight: Integer): Boolean; override;
    procedure DoExit; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent);override;
    destructor Destroy; override;

    property BaseDate     : TDateTime          read FBaseDate;
    property Date         : TDateTime          read FDate         write SetDate;
    property FirstDate    : TDateTime  index 1 read GetDate;
    property LastDate     : TDateTime  index 2 read GetDate;
    property GengoCombo   : TComboBox          read FGengoCombo;
    property ShihanCombo  : TComboBox          read FShihanCombo;
    property YearEdit     : TplShihanEditEdit  read FYearEdit;
    property YearLabel    : TplShihanEditLabel read FYearLabel;
    property GengoYear    : Integer   index 1  read GetDateInt;
    property Year         : Integer   index 2  read GetDateInt;
    property GengoStr     : String    index 0  read GetDateStr;
    property GengoYearStr : String    index 1  read GetDateStr;
    property YearStr      : String    index 2  read GetDateStr;
    property ShihanStr    : String    index 3  read GetDateStr;
    property IsEmpty      : Boolean            read GetIsEmpty;
    property Focused      : Boolean            read FFocused;
    procedure SetEditEmpty;
  published
    property Anchors;
    property Enabled;
    property Font;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property Visible;
    property OnEnter;
    property OnExit;

    property DisplayError     : Boolean               read FDisplayError     write FDisplayError;
    property CanEmpty         : Boolean               read FCanEmpty         write FCanEmpty;
    property EditStyle        : TplShihanEditStyle    read FEditStyle        write SetEditStyle;
    property EditGengo        : Boolean               read FEditGengo        write SetEditGengo;
    property Yeardigit        : TplYeardigitsSet      read FYeardigit        write SetYeardigit;

    property AutoSelect       : Boolean               read FAutoSelect       write FAutoSelect;
    property Gengo            : Boolean               read FGengo            write SetGengo;
    property DisableColor     : TColor                read FDisableColor     write SetDisableColor;
    property DisableFontColor : TColor                read FDisableFontColor write SetDisableFontColor;
    property DropDownKey      : Boolean               read FDropDownKey      write FDropDownKey;
    property EnterNext        : Boolean               read FEnterNext        write FEnterNext;
    property ExitCheck        : Boolean               read FExitCheck        write FExitCheck;
    property FocusedColor     : TColor                read FFocusedColor     write FFocusedColor;
    property TabStop          : Boolean               read FTabStop          write SetControlTabStop;
    property Color            : TColor                read FColor            write SetControlColor;
    property OnKeyPress       : TKeyPressEvent        read FOnKeyPress       write FOnkeyPress;
    property OnKeyDown        : TKeyEvent             read FOnKeyDown        write FOnkeyDown;
    property OnChange         : TNotifyEvent          read FOnChange         write FOnChange;
    property OnClick          : TNotifyEvent          read FOnClick          write FOnClick;
  end;

procedure Register;

implementation

{$IF CompilerVersion > 14.99}
uses Themes;
{$IFEND}

{ TplShihanEdit}

//=============================================================================
//  R|[lg
//  ̃R|[lg̏Ɗ֌W鏉SetParentŎs.
//  ̃R|̂ɃtH[JXړ[Tab]̓Ȃǂ܂Ȃ̂Ō
//  TabStop=Falseɂ,ʂTabStop`.
//  Colorʒ`ɂĂ.
//=============================================================================
constructor TplShihanEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOWner);
  inherited TabStop := False;

  ParentColor := True;
  FAutoSelect := True;
end;

//=============================================================================
//  R|[lg̃[hI
//  ݂̂Ƃ͓ɏȂ
//=============================================================================
procedure TplShihanEdit.Loaded;
begin
  inherited Loaded;
end;

//=============================================================================
//  R|[lgj
//  ݂̂Ƃ͓ɏȂ
//=============================================================================
destructor TplShihanEdit.Destroy;
begin
  inherited Destroy;
end;

{$IFDEF CONDITIONALEXPRESSIONS}
{$IF RTLVersion >= 24.0}
class constructor TplShihanEdit.Create;
{$IF RTLVersion >= 26.0}
var
  I: Integer;
{$IFEND}
begin
  FFormatSettings := TFormatSettings.Create;
  FFormatSettings.ShortDateFormat := 'YYYY/MM/DD';
{$IF RTLVersion >= 26.0}
  MaxEraCount := Length(FormatSettings.EraInfo);
  SetLength(EraNames, MaxEraCount + 1);
  SetLength(EraYearOffsets, MaxEraCount + 1);
  for I := 0 to MaxEraCount - 1 do
  begin
    EraNames[I + 1] := FormatSettings.EraInfo[I].EraName;
    EraYearOffsets[I + 1] := FormatSettings.EraInfo[I].EraOffset;
  end;
{$IFEND}
end;
{$IFEND}
{$ENDIF}


{$IFDEF CONDITIONALEXPRESSIONS}
{$IF RTLVersion >= 24.0}
function TplShihanEdit.FormatDateTime(const Format: string;
  DateTime: TDateTime): string;
begin
  Result := System.SysUtils.FormatDateTime(Format, DateTime, FFormatSettings);
end;
{$IFEND}
{$ENDIF}

//=============================================================================
//  eRg[̐ƃR|vpeB̏
//
//  Rg[̈ʒuƍSetControlResizePosition\bhŐݒ
//  Rg[͈̐ԍ̌IR{
//=============================================================================
procedure TplShihanEdit.SetParent(AParent: TWinControl);
begin
  inherited;

  if AParent = nil then exit;

  if FGengoCombo = nil then begin
    //{R|̂Captionsv
    Caption := '';

    Canvas.Font := Font;
    FColor      := clWhite;
    //IR{{bNX̍쐬Ə
    FGengoCombo := TComboBox.Create(Self);
    CreateComboBox(FGengoCombo);
    //Ԃ͌IŔN,,D͂͂Ȃ
    FEditGengo := True;

    //珇ԂɌ߂ĂȂ,Rg[̍ɂ킸̌ԂłĂ܂
    //t͕Ƃ̉Ẽx̍쐬
    FYearEdit   := TplShihanEditEdit.Create(Self);
    CreateEditBox(FYearEdit);

    FYearLabel  := TplShihanEditLabel.Create(Self);
    CreateLabel (FYearLabel);

    FShihanCombo := TComboBox.Create(Self);
    CreateComboBox(FShihanCombo);

    //evpeB̏
{$IFDEF CONDITIONALEXPRESSIONS}
{$IF RTLVersion < 24.0}
    ShortDateFormat   := 'YYYY/MM/DD';
{$IFEND}
{$ENDIF}
    FBaseDate         := VarToDateTime('1873/01/01');
    FDate             := FBaseDate-1;
    FCanEmpty         := True;
    FGengo            := True;
    FDisableColor     := clGray;
    FDisableFontColor := clWhite;
    FDropDownKey      := True;
    FIsEmpty          := True;
    FEnterNext        := True;
    FExitCheck        := False;
    FDisplayError     := True;
    FFocusedColor     := clAqua;

    FTabStop        := True;
    FYeardigit      := yddigit4;
    //eRg[̕ƈʒuݒ肵ĕ\
    SetControlResizePosition(True);
  end;
end;

//=============================================================================
//  IpR{{bNX̐Ə
//=============================================================================
procedure TplShihanEdit.CreateComboBox(ACombo: TComboBox);
var
  i : Integer;
begin
  with ACombo do begin
    Parent       := Self;
    ParentFont   := False;
    Left         := 0;
    Style        := csOwnerDrawFixed;
    ImeMode      := imDisable;
    OnEnter      := EditEnter;
    OnExit       := EditExit;
    OnKeyPress   := EditKeyPress;
    OnKeyDown    := EditKeyDown;
    OnDropDown   := GengoDropDown;
    OnDrawItem   := GengoDrawItem;
    OnChange     := EditChange;
    OnClick      := EditClick;
    OnMouseWheel := ComboMouseWheel;

    Items.Clear;
    if ACombo = FGengoCombo then begin
      //IItem̍쐬
      Items.Add('');
      for i := 1 to MaxEraCount do begin
        if EraNames[i] = '' then break;
        Items.Add(EraNames[i]);
      end;
    end;
    DefHeightItemHeightCombo := Height - ItemHeight;
  end;
end;

//=============================================================================
//  ͗̃Rg[̐Ə
//  TEditł͂ȂTMemo(NXtplShihanEditEdidɕύX)1s̃Gfbg{bNX
//  Ƃėp
//  (E񂹂Ɠ͕̐ݒ肪ȒPȂ̂)
//=============================================================================
procedure TplShihanEdit.CreateEditBox(AMemo: TplShihanEditEdit);
begin
  with AMemo do begin
    Parent      := Self;
    ParentFont  := False;
    WantReturns := False;
    WantTabs    := False;
    WordWrap    := False;
    Alignment   := taRightJustify;
    ImeMode     := imDisable;
    Color       := FColor;
    OnEnter     := EditEnter;
    OnExit      := EditExit;
    OnKeyPress  := EditKeyPress;
    OnKeyDown   := EditKeyDown;
    OnChange    := EditChange;
    OnClick     := EditClick;
    MaxLength   := 2;
  end;
end;

//=============================================================================
//  ͗̉ẼxRg[
//=============================================================================
procedure TplShihanEdit.CreateLabel(ALabel: TplShihanEditLabel );
begin
  with ALabel do begin
    Parent       := Self;
    ParentFont   := False;
    ParentColor  := False;
    Color        := $00E4E4E4;
    TabStop      := False;
    ControlStyle := ALabel.ControlStyle - [csAcceptsControls];
    FplDate      := Self;
  end;
end;

//=============================================================================
//  FontvpeBύXꂽ̃bZ[W̏
//  eRg[̃TCYs
//=============================================================================
procedure TplShihanEdit.CMFontChanged(var Message: TWMNoParams);
begin
  inherited;
  SetControlResizePosition(False);
end;

//=============================================================================
//  \Rg[̐ݒ
//  EditStylevpeBp
//  ݂̒l̓Zbg
//=============================================================================
procedure TplShihanEdit.SetEditStyle(const Value: TplShihanEditStyle);
begin
  if FEditStyle <> Value then begin
    FEditStyle := Value;
    SetControlResizePosition(True);
  end;
end;

//=============================================================================
//  ̓R{{bNX̕\\̐ݒ
//  EditGengo(Boolean)vpeBp
//  \̎͐͂Ɖ߂,a\sɂ
//=============================================================================
procedure TplShihanEdit.SetEditGengo(const Value: Boolean);
begin
  if FEditGengo <> Value then begin
    if Value=False then begin
      FEditGengo := False;
      FGengo     := False;
      FGengoCombo.Visible := False;
    end else begin
      FEditGengo := True;
      FGengoCombo.Visible := True;
    end;
    //TplDateEditVer2.1ŏC
    SetControlResizePosition(False);
    if (csReading in ComponentState) then exit;
    if not FIsEmpty then GetProperties;
  end;
end;

//=============================================================================
//  ̕\̐ݒ
//  yddigit2 2
//  yddigit4 4
//=============================================================================
procedure TplShihanEdit.SetYeardigit(const Value: TplYeardigitsSet);
begin
  if FYeardigit <> Value then begin
    FYeardigit := Value;
    SetControlResizePosition(False);
    if not FIsEmpty then GetProperties;
  end;
end;

//=============================================================================
//  \Rg[̕\ƈʒu̐ݒ
//  \ȂRg[̕0Ŕ\
//=============================================================================
procedure TplShihanEdit.SetControlResizePosition(EmptyFlag:Boolean=True);
var
  ALeft   : Integer;
  Metrics : TTextMetric;
  I       : Integer;
begin
  if FGengoCombo = nil then exit;

  fgResize := True;

  //U͗Sċɂ
  if EmptyFlag then begin
    SetEditEmpty;
    FShihanCombo.Items.Clear;
    case FEditStyle of
      NendoShihanki,NenShihanki:
      begin
        with FShihanCombo do begin
          Items.Add('Pl');
          Items.Add('Ql');
          Items.Add('Rl');
          Items.Add('Sl');
        end;
      end;
      NendoHanki,NenHanki:
      begin
        with FShihanCombo do begin
          Items.Add('㔼');
          Items.Add('');
        end;
      end;
    end;
    if (FEditStyle = NenShihanki) or (FEditStyle = NenHanki) then begin
      FYearLabel.Text := 'N';
    end else begin
      FYearLabel.Text := 'Nx';
    end;
  end;

  Canvas.Font.Assign(Font);
  GetTextMetrics(Canvas.Handle, Metrics);
  I := GetSystemMetrics(SM_CYBORDER)*8;
  //̃R|̍
  Height := Metrics.tmHeight + I;

  if FEditGengo then begin
    FGengoCombo.Font.Size  := Canvas.Font.Size;
    FGengoCombo.Font.Color := Canvas.Font.Color;
    FGengoCombo.ItemHeight := Height - DefHeightItemHeightCombo;
    FGengoCombo.Width      := Canvas.TextWidth(FGengoCombo.Items[1]) + 28;
    ALeft                  := FGengoCombo.Width; //-2
  end else begin
    FGengoCombo.Width := 0;
    ALeft := 0;
  end;
    FYearEdit.Font  := Canvas.Font;
  FYearEdit.Height := Height;
  if FYeardigit = yddigit4 then begin
    FYearEdit.MaxLength := 4;
    FYearEdit.Width     := Canvas.TextWidth('0000') + 12;
  end else begin
    FYearEdit.MaxLength := 2;
    FYearEdit.Width     := Canvas.TextWidth('00') + 12;
  end;

  FYearLabel.Font.Size  := Canvas.Font.Size;
  FYearLabel.Font.Style := [];
  FYearLabel.Font.Color := clBlack;
  FYearLabel.Height     := Height;
  FYearLabel.Width      := Canvas.TextWidth(FYearLabel.Text) + 10;

  FShihanCombo.Font.Size  := Canvas.Font.Size;
  FShihanCombo.Font.Color := Canvas.Font.Color;
  FShihanCombo.ItemHeight := Height - DefHeightItemHeightCombo;
  FShihanCombo.Width      := Canvas.TextWidth(FShihanCombo.Items[1]) + 28;

  FYearEdit.Left   := ALeft;
  FYearLabel.Left  := FYearEdit.Left    + FYearEdit.Width;
  FShihanCombo.Left:= FYearLabel.Left   + FYearLabel.Width;
  Width            := FShihanCombo.Left + FShihanCombo.Width;
  //TCY̒IÕTCY֎~
  fgResize := False;
end;

{ TplShihanEditLabel }

//=============================================================================
//  Nx܂͔N̕`
//=============================================================================
procedure TplShihanEditLabel.Paint;
var
  ARect    : TRect;
  AEge     : UINT;
  AGrfFlag : UINT;
  uFormat  : UINT;
begin
  inherited;
  if FplDate = nil then exit;

  //x̘g̃GbWނ`.XPe[}̏ꍇ̓tbgȘg
  //OSWindows XPł}jtFXgw肳Ăꍇ
  {$IF CompilerVersion > 14.99}
  if ThemeServices.ThemesEnabled then begin
    AEge     := BDR_RAISEDOUTER;
    AGrfFlag := BF_FLAT or BF_RECT;
  end else begin
    AEge     := EDGE_SUNKEN;
    AGrfFlag := BF_RECT;
  end;
  {$ELSE}
  AEge     := EDGE_SUNKEN;
  AGrfFlag := BF_RECT;
  {$IFEND}

  //tHgTCY
  Canvas.Font.Assign(Font);

  //`̃ACg.1ŝ.㉺E
  uFormat := DT_SINGLELINE or DT_CENTER or DT_VCENTER;
  //xgƕ`
  ARect := ClientRect;
  DrawEdge(Canvas.Handle, ARect, AEge, AGrfFlag);
  SetBkMode(Canvas.Handle, TRANSPARENT);
  DrawText(Canvas.Handle, PChar(Text), -1, ARect, uFormat);
end;

{ TplShihanEdit }

//=============================================================================
//  ͗Sċɂ
//=============================================================================
procedure TplShihanEdit.SetEditEmpty;
begin
  FYear         := 0;
  FYearStr      := '';
  FGengoYear    := 0;
  FGengoYearStr := '';
  FGengoStr     := '';

  FGengoCombo.ItemIndex  := -1;
  FShihanCombo.ItemIndex := -1;
  BeginDate              := FBaseDate - 1;
  FYearEdit.Text         := '';
  FIsEmpty               := True;
end;

//=============================================================================
//  DateTime^̒lFDateɑ
//  ƔN͗ɁC݂̓t̎l܂͔IԂɂ
//=============================================================================
procedure TplShihanEdit.SetDate(const Value: TDateTime);
const
  ErrorS1='ȂtZbg܂D@@';
var
  AYear  : WORD;
  AMonth : WORD;
  ADay   : WORD;
begin
  if csReading in ComponentState then exit;
  try
    FDate := Value;
    DecodeDate(FDate, AYear, AMonth, ADay);
    case FEditStyle of

      NendoShihanki:
      begin
        if (AMonth >= 1) and (AMonth <= 3) then begin
          FYearEdit.Text := IntToStr(AYear - 1);
          FShihanCombo.ItemIndex := 3;
          BeginDate := EncodeDate(AYear - 1, 4, 1);
        end else begin
          if (AMonth >= 4) and (AMonth <= 6) then begin
            FShihanCombo.ItemIndex := 0;
          end else
          if (AMonth >= 7) and (AMonth <= 9) then begin
            FShihanCombo.ItemIndex := 1;
          end else
          if (AMonth >= 10) and (AMonth <= 12) then begin
            FShihanCombo.ItemIndex := 2;
          end;
          FYearEdit.Text := IntToStr(AYear);
          BeginDate := EncodeDate(AYear, 4, 1);
        end;
      end;

      NendoHanki:
      begin
        if (AMonth >= 1) and (AMonth <= 3) then begin
          FYearEdit.Text := IntToStr(AYear - 1);
          FShihanCombo.ItemIndex := 1;
          BeginDate := EncodeDate(AYear - 1, 4, 1);
        end else begin
          if (AMonth >= 4) and (AMonth <= 9) then begin
            FShihanCombo.ItemIndex := 0;
          end else
          if (AMonth >= 10) and (AMonth <= 12) then begin
            FShihanCombo.ItemIndex := 1;
          end;
          FYearEdit.Text := IntToStr(AYear);
          BeginDate := EncodeDate(AYear, 4, 1);
        end;
      end;

      NenShihanki:
      begin
        if (AMonth >= 1) and (AMonth <= 3) then begin
          FShihanCombo.ItemIndex := 0;
        end else
        if (AMonth >= 4) and (AMonth <= 6) then begin
          FShihanCombo.ItemIndex := 1;
        end else
        if (AMonth >= 7) and (AMonth <= 9) then begin
          FShihanCombo.ItemIndex := 2;
        end else
       if (AMonth >= 10) and (AMonth <= 12) then begin
          FShihanCombo.ItemIndex := 3;
        end;
        FYearEdit.Text := IntToStr(AYear);
        BeginDate := EncodeDate(AYear, 1, 1);
      end;

      NenHanki:
      begin
        if (AMonth >= 1) and (AMonth <= 6) then begin
          FShihanCombo.ItemIndex := 0;
        end else
        if (AMonth >= 7) and (AMonth <= 12) then begin
          FShihanCombo.ItemIndex := 1;
        end;
        FYearEdit.Text := IntToStr(AYear);
        BeginDate := EncodeDate(AYear, 1, 1);
      end;
    end;
    GetProperties;
  except
    ShowErrorDialog(ErrorS1, nil);
  end;
end;

//=============================================================================
//  a\
//  IXg\̎͘a\͂Ȃ
//=============================================================================
procedure TplShihanEdit.SetGengo(const Value: Boolean);
begin
  if FGengo <> Value then begin
    if FEditGengo then begin
      FGengo := Value;
    end else begin
      FGengo := False;
    end;
    if (csReading in ComponentState) then exit;
    if (csDesigning in ComponentState) then exit;
    if not FIsEmpty then CheckDateError;
  end;
end;

//=============================================================================
//  eRg[̓͒lvZ̊ƂȂDateTime^̓tvZ
//  G[̎True
//  l: FBaseDate := StrToDateTime('1873/01/01');
//=============================================================================
function TplShihanEdit.CheckDateError: Boolean;
const
  ErrorS10 ='1873N(6N)O͏ł܂D@@';
  ErrorS11 ='͗Sċ󔒂łD@@';
  ErrorS12 ='󔒂̓͗܂D@@';
  ErrorS13 ='łȂNx܂͗NłD@@';

var
  StrGengo    : String;
  StrShihan   : String;
  dYear       : WORD;
  FlagGengo   : Boolean;
  FlagYear    : Boolean;
  FlagShihan  : Boolean;

  StrYear  : String;
  i        : Integer;
  AIndex   : Integer;
begin
   Result := True;

   if EditGengo = False then FGengoCombo.ItemIndex := -1;

   StrGengo  := Trim(FGengoCombo.Text);
   StrYear   := Trim(FYearEdit.Text);
   StrShihan := Trim(FShihanCombo.Text);

   FlagGengo := (StrGengo  = '' )  and FGengoCombo.Visible;
   FlagYear  := (StrYear   = ''  ) and FYearEdit.Visible;
   FlagShihan:= (StrShihan = '')   and FShihanCombo.Visible;

   //͗Sċ󔒂̏ꍇ
   if GetIsEmpty then begin
     FIsEmpty := True;
     //󔒓͂ĂȂꍇ
     if FCanEmpty = False then begin
       ShowErrorDialog(ErrorS11, nil);
     end else begin
       //t֌W̎擾vpeBlɂăG[ȂŏI
       SetEditEmpty;
       Result := False;
       exit;
     end;
   //ǂꂩ̓̓Rg[̒l̏ꍇ
   end else if FlagYear or FlagShihan then begin
     FIsEmpty := False;
     //󔒓͂ĂĂ1ł͂ꍇ̓G[
     //󔒋Ƃ͑S͗󔒂̏ꍇӖ
     if FlagGengo  then ShowErrorDialog(ErrorS12, FGengoCombo);
     if FlagYear   then ShowErrorDialog(ErrorS12, FYearEdit);
     if FlagShihan then ShowErrorDialog(ErrorS12, FShihanCombo);
   //SĂ̗܂͌IXgȊO͂Ăꍇ
   end else begin
     FIsEmpty := False;
     AIndex := 0;
     if FEditGengo then begin
       for i := 0 to FGengoCombo.Items.Count - 1 do begin
         if FGengoCombo.Items[i] = StrGengo then begin
           AIndex := i;
           break;
         end;
       end;
     end;
     //IXg󔒂̎͐NƂ݂Ȃ
     if AIndex = 0 then begin
       dYear := StrToIntDef(StrYear, 0);
       //͂̎ɔN̓͌2(FYeardigit=2)̎͐̉2Ƃ݂Ȃ
       if FYeardigit = yddigit2 then begin
         dYear := dYear+(StrToInt(FormatDateTime('yyyy',Now)) div 100) * 100;
       end;
     end else begin
       dYear := EraYearOffsets[AIndex] - 1 + StrToIntDef(StrYear, 0);
     end;
   end;

   //tɕϊăG[ȂȂ炻ꂪt
   //1873.1.1(6N11)O̓G[
   //2088N(99N)ȏŘa\̎G[
   //G[łȂGetPropertiesŊevpeBĎ擾
   if (FEditStyle = NendoShihanki) or (FEditStyle = NendoHanki) then begin
     BeginDate := Trunc(EncodeDate(dYear, 4, 1));
   end else begin
     BeginDate := Trunc(EncodeDate(dYear, 1, 1));
   end;
   if (dYear<1873) then begin
     ShowErrorDialog(ErrorS12, FYearEdit);
   end else if (dYear >= 2088) and (FGengo) then begin
     ShowErrorDialog(ErrorS13, FYearEdit);
   end else begin
     Result := False;
   end;

   //G[łȂGetPropertiesŊevpeBĎ擾
   if not Result then begin
     try
       GetProperties;
     except
       ShowErrorDialog(ErrorS13, nil);
     end;
   end;
end;

//=============================================================================
//  G[_CAO̕\
//
//  vpeB擾̍,G[ɂ̃\bhďo
//  G[ƃTCgÔ,ȉ̗lɏ邱Ƃ
//  .
//
//  try
//    //擾vpeBȂ牽ł`FbN\
//    plShihanEdit1.StartDate;
//  except
//    //_CAO\Ȃǂ̃G[̏
//  end;
//=============================================================================
procedure TplShihanEdit.ShowErrorDialog(ERStr: String; AWinControl: TWinControl);
begin
  if FDisplayError then begin
    Application.MessageBox(PChar(ERStr), PChar(FDialogCaption), MB_OK + MB_ICONINFORMATION);
  end;
  SetControlFocus(AWinControl);
  Abort;
end;

//=============================================================================
//  BiginDate(NPʂ̎11CNxPʂ̎41)evpeB擾
//  ČC\(FGengovpeB)̒lɉčĕ\D
//  ̊֐́CDatevpeBɒlZbgďoĂD
//
//  l: FBaseDate := StrToDateTime('1873/01/01');
//=============================================================================
function TplShihanEdit.GetProperties : Boolean;
var
  i : Integer;
begin
  Result := True;
  //1873.1.1(6N11)O͉Ȃ
  if BeginDate >= FBaseDate then begin
    FIsEmpty := False;
    try
      FYear      := StrToInt(FormatDateTime ('yyyy', BeginDate)); //N
      FGengoStr  := FormatDateTime          ('ggg',  BeginDate);  //
      FGengoYear := StrToInt(FormatDateTime ('e',    BeginDate)); //N
      //\̎w͌Ď擾(aɂȂ邩mȂ
      //FGengoStrƓItemIndex̕R{ɕ\
      if FGengo then begin
        FGengoCombo.Text := FGengoStr;
        for i := 1 to MaxEraCount do begin
          if EraNames[i] = FGengoStr then begin
            FGengoCombo.ItemIndex := i;
            break;
          end;
        end;
        FYearEdit.Text := IntToStr(FGengoYear);
       //\w̎
      end else begin
        //ItemIndex0Œ
        //ĨR{łĂŕ\
        //\2̏ꍇ(FYeardigit=yddigit2)͉2̂ݕ\
        FGengoCombo.ItemIndex := 0;
        FYearStr := IntToStr(FYear);
        if FYeardigit = yddigit2 then begin
          FYearEdit.Text := Copy(FYearStr, Length(FYearStr) - 1, Length(FYearStr));
        end else begin
          FYearEdit.Text := FYearStr;
        end;
      end;
      FGengoYearStr := IntToStr(FGengoYear);
    except
      Result := False;
    end;
  end else begin
    Result := False;
  end;
end;

//=============================================================================
//  l܂͔̍ŏƍŌ̓t擾
//  1: ŏ̓t
//  2: Ō̓t
//=============================================================================
function TplShihanEdit.GetDate(index : Integer): TDateTime;
begin
  Result := FBaseDate;
  if CheckDateError = False then begin
    case Index of
      1:
      begin
        if (FEditStyle = NendoShihanki) or (FEditStyle = NenShihanki) then begin
          Result := IncMonth(BeginDate, FShihanCombo.ItemIndex * 3);
        end else begin
          Result := IncMonth(BeginDate, FShihanCombo.ItemIndex * 6);
        end;
      end;
      2:
      begin
        if (FEditStyle = NendoShihanki) or (FEditStyle = NenShihanki) then begin
          Result := IncMonth(BeginDate - 1, (FShihanCombo.ItemIndex + 1) * 3);
        end else begin
          Result := IncMonth(BeginDate - 1, (FShihanCombo.ItemIndex + 1) * 6);
        end;
      end;
    end;
  end;
end;

//=============================================================================
//  N̒l()擾
//  0: ̕
//  1: ̔N
//  2: N
//  3: l܂̕
//=============================================================================
function TplShihanEdit.GetDateStr(Index: Integer): String;
begin
  Result := '';
  if CheckDateError = False then begin
    case Index of
      0: Result := FGengoStr;
      1: Result := FGengoYearStr;
      2: Result := FYearStr;
      3: Result := FShihanCombo.Text;
    end;
  end;
end;

//=============================================================================
//  N̒l(l)擾
//  1: ̔N
//  2: N
//=============================================================================
function TplShihanEdit.GetDateInt(Index: Integer): Integer;
begin
  Result := 0;
  if CheckDateError = False then begin
    case Index of
      1: Result := FGengoYear;
      2: Result := FYear;
    end;
  end;
end;

//=============================================================================
//  e͒l󔒂ǂo
//
//  g̗
//
//  if plShihanEdit1.IsEmpty then begin
//    //󔒂̎̏
//  end else bggin
//    //͂t擾ď
//    MyDate := plShihanEdit1.Date;
//  end;
//=============================================================================
function TplShihanEdit.GetIsEmpty: Boolean;
begin
  Result := False;
  if (FGengoCombo. Text = '') and
     (FYearEdit  . Text = '') and
     (FShihanCombo.Text = '') then Result := True;
end;

//=============================================================================
//  TabStopvpeB̐ݒ
//  TabStopTrueɂ,[Tab]ړōŏ̃Rg[ɃtH[JXړ
//  Ȃ.܂[Shift]+[Tab]̈ړȂ.
//=============================================================================
procedure TplShihanEdit.SetControlTabStop(const Value: Boolean);
begin
  FTabStop := Value;
  inherited TabStop    := False;
  FGengoCombo.TabStop  := FTabStop;
  FYearEdit.TabStop    := FTabStop;
  FShihanCombo.TabStop := FTabStop;
end;

//=============================================================================
//  ̃R|̓TCYsƂ
//=============================================================================
function TplShihanEdit.CanResize(var NewWidth, NewHeight: Integer): Boolean;
begin
  Result := False;
  if (FGengoCombo = nil) or (FShihanCombo = nil) then exit;
  if (csReading in ComponentState) then exit;
  if fgResize = False then begin
    Result := False;
  end else begin
    Result := True;
  end;
end;

//=============================================================================
//  ̃R|SetFocus\Ă鍶[̃Rg[ɃtH[JXړ
//
//  AWinControl  ړ̃Rg[
//=============================================================================
procedure TplShihanEdit.SetControlFocus(AWinControl: TWinControl);
begin
  if Enabled and Visible then begin
    if AWinControl=nil then begin
      if (FGengoCombo.Visible) and (FGengoCombo.Enabled) then begin
        FGengoCombo.SetFocus;
      end else
      if (FYearEdit.Visible) and (FYearEdit.Enabled) then begin
        FYearEdit.SetFocus;
      end else
      if (FShihanCombo.Visible) and (FShihanCombo.Enabled) then begin
        FShihanCombo.SetFocus;
      end else begin
        FFocused := False;
      end;
    end else begin
      if TWinControl(AWinControl).Visible and TWinControl(AWinControl).Enabled then begin
        AWinControl.SetFocus;
      end else begin
        FFocused := False;
      end;
    end;
    FFocused := True;
  end;
end;

//=============================================================================
//  R|EnabledvpeBύXꂽɃR|gɑĂ
//  Cm_EnabledChangedbZ[W̏D
//  Enabled=True,Enabled=False(Disabled)ɉē͗pRg[̔wiFƕ
//  FύX.
//=============================================================================
procedure TplShihanEdit.CMEnabledChanged(var Message: TWMNoParams);
begin
  inherited;
  SetEditColor;
end;

//=============================================================================
//  ColorvpeBύXƂȂ̏
//  ColorvpeB͌p̂ł͂Ȃ,ʂɒ`Ă.
//=============================================================================
procedure TplShihanEdit.SetControlColor(const Value: TColor);
begin
  if FColor <> Value then begin
    FColor := Value;
    SetEditColor;
  end;
end;

//=============================================================================
//  Enabledv̓peBɂăRg[̔wiFς
//=============================================================================
procedure TplShihanEdit.SetEditColor;
begin
  if Enabled = False then begin
    FGengoCombo.Enabled    := False;
    FShihanCombo.Enabled   := False;
    FGengoCombo.Color      := FDisableColor;
    FYearEdit.Color        := FDisableColor;
    FSHihanCombo.Color     := FDisableColor;

    FGengoCombo.Font.Color  := FDisableFontColor;
    FYearEdit.Font.Color    := FDisableFontColor;
    FShihanCombo.Font.Color :=FDisableFontColor;
  end else begin
    FGengoCombo.Enabled    := True;
    FShihanCombo.Enabled   := True;
    FGengoCombo.Color      := FColor;
    FYearEdit.Color        := FColor;
    FShihanCombo.Color     := FColor;

    FGengoCombo.Font.Color   := Font.Color;
    FYearEdit.Font.Color     := Font.Color;
    FShihanCombo.Font.Color  := Font.Color;
  end;
end;

//=============================================================================
//  EnabelvpeBFalse̎̓̓Rg[̔wiF̐ݒ
//  Ver1.1Œǉ
//=============================================================================
procedure TplShihanEdit.SetDisableColor(const Value: TColor);
begin
  if FDisableColor <> Value then begin
    FDisableColor := Value;
    SetEditColor;
  end;
end;

//=============================================================================
//  EnabledvpeBFalse̎̓̓Rg[̐̕Fݒ
//=============================================================================
procedure TplShihanEdit.SetDisableFontColor(const Value: TColor);
begin
  if FDisableFontColor <> Value then begin
    FDisableFontColor := Value;
    SetEditColor;
  end;
end;

//=============================================================================
//  tH[JX̏
//  R|gTabStopFalseɂĂ̂ŌIN̓Rg[ɃtH
//  [JX.
//=============================================================================
procedure TplShihanEdit.WMSetFocus(var Message: TWMSetFocus);
begin
  inherited;
  SetControlFocus(nil);
end;

//=============================================================================
//  Rg[ActiveɂȂeLXgIԂ
//=============================================================================
procedure TplShihanEdit.EditEnter(Sender: TObject);
begin
  fgTabStop := FTabStop;
  if fgTabStop = False then begin
    FGengoCombo.TabStop  := True;
    FYearEdit.TabStop    := True;
    FShihanCombo.TabStop := True;
  end;

  if Sender is TComboBox then begin
    if TComboBox(Sender).Visible then begin
      TComboBox(Sender).SetFocus;
      TComboBox(Sender).Color := FFocusedColor;
      if FAutoSelect then TComboBox(Sender).SelectAll;
    end;
  end;
  if Sender is TplShihanEditEdit then begin
    TplShihanEditEdit(Sender).SetFocus;
    TplShihanEditEdit(Sender).Color := FFocusedColor;
    if FAutoSelect then begin
      TplShihanEditEdit(Sender).SelectAll;
    end else begin
      TplShihanEditEdit(Sender).SelStart := 0;
    end;
  end;
end;

//=============================================================================
//  Rg[ActivełȂȂwiFɖ߂
//=============================================================================
procedure TplShihanEdit.EditExit(Sender: TObject);
begin
  if TComboBox(Sender).Visible then TComboBox(Sender).Color := FColor;
  TplShihanEditEdit(Sender).Color := FColor;
end;

//=============================================================================
//  ̃R|ActivełȂȂꍇ
//  ̌oƂĂWM_KILLFOCUŜł邪,̃R|ł,tH[JX
//  ړĂɍ[̃Rg[ɃtH[JXړĂ邽,̎
//  KillFocsuĂ܂.
//=============================================================================
procedure TplShihanEdit.DoExit;
begin
  inherited;
  //Rg[̕IԂ̏ꍇlĉĂ
  FYearEdit.SelStart;
  if FExitCheck then CheckDateError;
  SetControlTabStop(fgTabStop);
  FFocused := False;
end;

//=============================================================================
//  ̃Xg\wiFύX
//  R{{bNXOnDropDownCxg
//  WindowsXPƂOOSƓقړɂ邽߂
//=============================================================================
procedure TplShihanEdit.GengoDropDown(Sender: TObject);
begin
  TComboBox(Sender).Color := FFocusedColor;
end;

//=============================================================================
//  IR{{bNXOnDrawItemCxgp
//  FFcosedColorȊO̎́CtH[JX̓_`悵Ȃ
//  l
//  R{{bNXEditɉ͂Ȃ́CDrawItem͔Ȃ
//=============================================================================
procedure TplShihanEdit.GengoDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  with TComboBox(Control) do begin
    if (FAutoSelect = False) and (FFocusedColor <> clWhite) then begin
        //I
        if odSelected in State then begin
          //Edit
          if odComboBoxEdit in State then begin
            Canvas.Brush.Style := bsClear;
          end else begin
            Canvas.Brush.Color := FFocusedColor;
          end;
        end else
        if odComboBoxEdit in State then begin
          Canvas.Brush.Style := bsClear;
        end else begin
          Canvas.Brush.Color := FColor;
        end;
        Canvas.Font.Assign(Font);
    end;
    Canvas.FillRect(Rect);
    Rect.Left  := Rect.Left + 2;
    DrawText(Canvas.Handle,
             PChar(Items[Index]),
             -1,
             Rect,
             DT_SINGLELINE or DT_VCENTER or DT_LEFT);
  end;
end;

//=============================================================================
//  [TAB]L[OnKeyDownCxgŏ\ɂ
//  O炱̃R|gpۂɕKv
//  ꂪȂƁCÕvO[Enter],[Tab]Ȃǂ̓L[ołȂ
//=============================================================================
procedure TplShihanEdit.CMWantSpecialKey(var Msg: TMessage);
begin
  if Msg.WParam=VK_TAB then Msg.Result := 1;
end;

//=============================================================================
//  }EXzC[ł̓R{{bNXJȂ
//=============================================================================
procedure TplShihanEdit.ComboMouseWheel(Sender: TObject;
  Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
begin
  if Screen.ActiveControl is TComboBox then begin
    Handled := True;
  end;
end;

//=============================================================================
//  L[͏
//  [Enter]KeyDownŏ̂ŉȂ
//  p͓͂łȂ. #8[BackSpace]. #27[Escape]
//=============================================================================
procedure TplShihanEdit.EditKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Assigned(FOnKeyPress) then FOnKeyPress(Sender,Key);
  if Key = #13 then begin
    Key := #0;
  end else begin
    if (Sender is TplShihanEditEdit) then begin
      if ((Key >= '0') and (Key <= '9')) or (Key = #8) or (Key = #27) then begin
        inherited KeyPress(Key);
      end else begin
        Key := #0;
      end;
    end else if (Sender is TComboBox) then begin
      if (Key=#8) or (Key=#27) then begin
        inherited KeyPress(Key);
      end else begin
        Key := #0;
      end;
    end else begin
      Key := #0;
    end;
  end;
end;

//=============================================================================
//  eL[̏
//  [DELETE]Ō̕NA\ɂ(Ver1.1)
//=============================================================================
procedure TplShihanEdit.EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Assigned(FOnKeyDown) then FOnKeyDown(Sender,Key,Shift);

  //R{{bNX[Enter]őI
  if Key = VK_RETURN then begin
    if TComboBox(Sender).Visible then TComboBox(Sender).DroppedDown := False;
    //̃^uRg[Ɉړ
    if FEnterNext then begin
      if (ssShift in Shift) then begin
        keybd_event( VK_TAB,   MapVirtualKey(VK_TAB, 0),   0, 0 );
        keybd_event( VK_SHIFT, MapVirtualKey(VK_SHIFT, 0), 0, 0 );
        keybd_event( VK_TAB,   MapVirtualKey(VK_TAB, 0),   KEYEVENTF_KEYUP , 0 );
        keybd_event( VK_SHIFT, MapVirtualKey(VK_SHIFT, 0), KEYEVENTF_KEYUP , 0 );
      end else begin
        keybd_event( VK_TAB, MapVirtualKey(VK_TAB, 0), 0 , 0 );
        keybd_event( VK_TAB, MapVirtualKey(VK_TAB, 0), KEYEVENTF_KEYUP , 0 );
      end;
    end;
  end else if Key = VK_TAB then begin
    if (ssShift in Shift) then begin
      TWinControl(FindNextControl(TWinControl(Sender), False, True, True)).Setfocus;
    end else begin
      TWinControl(FindNextControl(TWinControl(Sender), True, True, True)).Setfocus;
    end;
  //ŃR{̃hbv_EXg\
  end else if Key = VK_DOWN then begin
    if FDropDownKey then begin
      if TComboBox(Sender).Visible then begin
        if (TComboBox(Sender).DroppedDown = False) then begin
          Key := 0;
          TComboBox(Sender).DroppedDown := True;
        end;
      end;
    end;
  end else if Key = VK_DELETE then begin
    if Sender is TComboBox then begin
      TComboBox(Sender).ItemIndex := -1;
    end;
  end;

  inherited;
end;

//=============================================================================
//   e̓Rg[OnChangeCxgnh
//=============================================================================
procedure TplShihanEdit.EditChange(Sender: TObject);
begin
  if Assigned(FOnChange) then FOnChange(Sender);
end;

//=============================================================================
//  e̓Rg[OnClickCxgnh
//  OnEnter̃Cxg`ƂOnClick͔Ȃ
//  (̃R|[lgƓ.m܂ł)
//=============================================================================
procedure TplShihanEdit.EditClick(Sender: TObject);
begin
  if Assigned(FOnClick) then FOnClick(Sender);
end;

//=============================================================================
//   R|[lgo^
//=============================================================================
procedure Register;
begin
  RegisterComponents('plXRAY', [TplShihanEdit]);
end;

//=============================================================================
//  R[hI
//=============================================================================
end.
