{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$WARNINGS OFF}
//=============================================================================
//  It̓R|[lg
//  Ver 9.03
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  dlCCmFɂĂ͓YtReadme.txtQ
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plDateEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, DB, DBCtrls, Variants;

type

  //͗̕\E\ݒ肷vf̒`
  //IXg̕\E\̐ݒEditGengovpeB
  TplDateEditStyle = ( desYearMonthDayHMS,   //Nb
                       desYearMonthDayHM,    //N
                       desYearMonthDayH,     //N
                       desYearMonthDay,      //N
                       desYearMonth,         //N
                       desYear,              //N
                       desHourMinuteSecond,  //b
                       desHourMinute,        //
                       desHour);             //

  //G[̎
  TplDateEditError = (derAllEmpty,          //SĂ̓͗
                      derYearEmpty,         //N̗
                      derMonthEmpty,        //̗
                      derDayEmpty,          //̗
                      derAMPMEmpty,         //ߑOߌ̗
                      derHourEmpty,         //̗
                      derMinuteEmpty,       //̗
                      derSecondEmpty,       //b̗
                      derBeforeBaseDate,    //6N11O̓tł
                      derDateTimeError,     //t^̕ϊG[
                      derDateError,         //t̕ϊG[
                      derTimeError,         //̕ϊG[
                      derSetDateTimeError,  //͂t^ϐl̊ԈႢ
                      derSetDateError,      //͂(DatevpeB̃Zbg)tԈႢ
                      derSetTimeError,      //͂(TimevpeB̃Zbg)ԈႢ
                      derChangeGengo);      //2088ȍ~͘aϊs\

  //N̓͌
  TplYeardigitSet = (yddigit2, yddigit4);

  //G[̎ނ̏W
  TplDateEditErrors = set of TplDateEditError;

  //TplDateEditLabeVer1.1Œǉ
  TplDateEdit = class;

  TplDateEditLabel = class(TCustomControl)
  private
    FplDate : TplDateEdit;
  protected
  public
    property Color;
    property Font;
    property Text;
    procedure Paint; override;
  published
  end;

  TplDateEditEdit = TMemo;

  TplDateEdit = class(TCustomControl)
  private
    FDateTime        : TDateTime;
    FDate            : TDateTime;

    FGengo           : Boolean;
    FBaseDate        : TDateTime;
    FCanEmpty        : Boolean;
    FIsEmpty         : Boolean;
    FAutoSelect      : Boolean;

    FGengoStr        : String;
    FGengoYear       : Integer;
    FGengoYearStr    : String;
    FAmpmStr         : String;

    FYear            : Integer;
    FMonth           : Integer;
    FDay             : Integer;
    FHour            : Integer;
    FMinute          : Integer;
    FSecond          : Integer;
    FYearStr         : String;
    FMonthStr        : String;
    FDayStr          : String;
    FHourStr         : String;
    FMinuteStr       : String;
    FSecondStr       : String;
    FYeardigit       : TplYeardigitSet;

    FFocusedColor    : TColor;
    FDisableFontColor: TColor;
    FDisableColor    : TColor;

    FYearEdit        : TplDateEditEdit;
    FMonthEdit       : TplDateEditEdit;
    FDayEdit         : TplDateEditEdit;
    FHourEdit        : TplDateEditEdit;
    FMinuteEdit      : TplDateEditEdit;
    FSecondEdit      : TplDateEditEdit;

    FYearLabel       : TplDateEditLabel;
    FMonthLabel      : TplDateEditLabel;
    FDayLabel        : TplDateEditLabel;
    FHourLabel       : TplDateEditLabel;
    FMinuteLabel     : TplDateEditLabel;
    FSecondLabel     : TplDateEditLabel;

    FLabelYear       : String;
    FLabelMonth      : String;
    FLabelDay        : String;
    FLabelHour       : String;
    FLabelMinute     : String;
    FLabelSecond     : String;
    FSpaceWidth      : Integer;

    FGengoCombo      : TComboBox;
    FAmpmCombo       : TComboBox;
    FEditGengo       : Boolean;
    FEditAmpm        : Boolean;

    FEnterNext       : Boolean;
    FExitCheck       : Boolean;
    FDisplayError    : Boolean;
    FDropDownKey     : Boolean;
    FDialogCaption   : String;
    FEditStyle       : TplDateEditStyle;
    FTabStop         : Boolean;
    FColor           : TColor;
    FErrorKinds      : TplDateEditErrors;
    FOnKeyPress      : TKeyPressEvent;
    FOnKeyDown       : TKeyEvent;
    FOnChange        : TNotifyEvent;
    FOnClick         : TNotifyEvent;
    FFocused         : Boolean;
    SingleHeight     : Integer;
    fgResize         : Boolean;      //TCYϐ
    fgTabStop        : Boolean;

    DefHeightItemHeightCombo : Integer;

    procedure SetDate(const Value: TDateTime);
    function GetDate: TDateTime;
    procedure SetGengo(const Value: Boolean);
    function GetProperties: Boolean;
    procedure SetEditStyle(const Value: TplDateEditStyle);
    procedure SetEditGengo(const Value: Boolean);
    procedure SetControlResizePosition(EmptyFlag:Boolean=True);
    function GetDateStr(index: Integer): String;
    function GetDateInt(index: Integer): Integer;
    procedure SetControlFocus(AWinControl: TWinControl);
    function GetIsEmpty: Boolean;
    function CheckDateError: Boolean;
    procedure ShowErrorDialog(ERStr: String; AWinControl: TWinControl);
    procedure EditKeyPress(Sender: TObject; var Key: Char);virtual;
    procedure EditKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);virtual;
    procedure EditChange(Sender: TObject); virtual;
    procedure EditClick (Sender: TObject); virtual;    
    procedure GengoDropDown(Sender: TObject);
    procedure EditEnter(Sender: TObject); virtual;
    procedure EditExit(Sender: TObject);
    procedure CreateComboBox(ACombo : TComboBox );
    procedure CreateLabel(ALabel: TplDateEditLabel; AText:String);
    procedure CreateEditBox(AMemo: TplDateEditEdit);
    procedure CMEnabledChanged(var Message: TWMNoParams); message CM_ENABLEDCHANGED;
    procedure CMFontChanged(var Message: TWMNoParams); message CM_FONTCHANGED;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure CMWantSpecialKey(var Msg: TMessage); message CM_WANTSPECIALKEY;
    procedure SetEditColor;
    procedure SetLabelCaption(const index: Integer; const Value: String);
    procedure SetControlTabStop(const Value: Boolean);
    procedure SetControlColor(const Value: TColor);
    procedure SetDisableColor(const Value: TColor);
    procedure SetDisableFontColor(const Value: TColor);
    procedure GengoDrawItem(Control: TWinControl; Index: Integer;
             Rect: TRect; State: TOwnerDrawState);
    procedure SetEditAmpm(const Value: Boolean);
    procedure ControlShowHide(Sender: TObject; ATop,AHeight: Integer; AFlag: Boolean);
    procedure SetSpaceWidth(const Value: Integer);
    procedure SetYeardigit(const Value: TplYeardigitSet);

{$IFDEF CONDITIONALEXPRESSIONS}
{$IF RTLVersion >= 24.0}
  class var
    FFormatSettings: TFormatSettings;
{$IF RTLVersion >= 26.0}
    MaxEraCount: Integer;
    EraNames: array of string;
    EraYearOffsets: array of Integer;
{$IFEND}
    class constructor Create;
    function FormatDateTime(const Format: string; DateTime: TDateTime): string;
{$IFEND}
{$ENDIF}
  protected
    procedure Loaded; override;
    procedure SetParent(AParent: TWinControl); override;
    function CanResize(var NewWidth, NewHeight: Integer): Boolean; override;

    procedure DoExit; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent);override;
    destructor Destroy; override;

    property BaseDate     : TDateTime         read FBaseDate;
    property DateTime     : TDateTime         read GetDate     write SetDate;
    property Date         : TDateTime         read GetDate     write SetDate;

    property GengoCombo   : TComboBox         read FGengoCombo;
    property AmpmCombo    : TComboBox         read FAmpmCombo;
    property YearEdit     : TplDateEditEdit   read FYearEdit;
    property MonthEdit    : TplDateEditEdit   read FMonthEdit;
    property DayEdit      : TplDateEditEdit   read FDayEdit;
    property HourEdit     : TplDateEditEdit   read FHourEdit;
    property MinuteEdit   : TplDateEditEdit   read FMinuteEdit;
    property SecondEdit   : TplDateEditEdit   read FSecondEdit;

    property YearLabel    : TplDateEditLabel  read FYearLabel;
    property MonthLabel   : TplDateEditLabel  read FMonthLabel;
    property DayLabel     : TplDateEditLabel  read FDayLabel;
    property HourLabel    : TplDateEditLabel  read FHourLabel;
    property MinuteLabel  : TplDateEditLabel  read FMinuteLabel;
    property SecondLabel  : TplDateEditLabel  read FSecondLabel;

    property GengoYear    : Integer   index 1 read GetDateInt;
    property Year         : Integer   index 2 read GetDateInt;
    property Month        : Integer   index 3 read GetDateInt;
    property Day          : Integer   index 4 read GetDateInt;
    property Hour         : Integer   index 5 read GetDateInt;
    property Minute       : Integer   index 6 read GetDateInt;
    property Second       : Integer   index 7 read GetDateInt;

    property GengoStr     : String    index 0 read GetDateStr;
    property GengoYearStr : String    index 1 read GetDateStr;
    property YearStr      : String    index 2 read GetDateStr;
    property MonthStr     : String    index 3 read GetDateStr;
    property DayStr       : String    index 4 read GetDateStr;
    property AmpmStr      : String    index 5 read GetDateStr;
    property HourStr      : String    index 6 read GetDateStr;
    property MinuteStr    : String    index 7 read GetDateStr;
    property SecondStr    : String    index 8 read GetDateStr;

    property IsEmpty      : Boolean           read GetIsEmpty;
    property ErrorKinds   : TplDateEditErrors read FErrorKinds;
    property Focused      : Boolean           read FFocused;
    function GetAge(Date1,Date2: TDateTime; AgeType:Integer; var gAge,gMonth: Integer): Boolean; overload;
    function ToGannenGanjitu(ADate: TDateTime; ToGanjitu: Boolean;
      NeedSpace:Boolean): string;
    procedure SetEditEmpty;
  published
    property Anchors;
    property Enabled;
    property Font;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property Visible;
    property OnEnter;
    property OnExit;

    property EditStyle        : TplDateEditStyle      read FEditStyle        write SetEditStyle;
    property EditGengo        : Boolean               read FEditGengo        write SetEditGengo;
    property EditAmpm         : Boolean               read FEditAmpm         write SetEditAmpm;
    property LabelYear        : String        index 1 read FLabelYear        write SetLabelCaption;
    property LabelMonth       : String        index 2 read FLabelMonth       write SetLabelCaption;
    property LabelDay         : String        index 3 read FLabelDay         write SetLabelCaption;
    property LabelHour        : String        index 4 read FLabelHour        write SetLabelCaption;
    property LabelMinute      : String        index 5 read FLabelMinute      write SetLabelCaption;
    property LabelSecond      : String        index 6 read FLabelSecond      write SetLabelCaption;
    property SpaceWidth       : Integer               read FSpaceWidth       write SetSpaceWidth;
    property Yeardigit        : TplYeardigitSet       read FYeardigit        write SetYeardigit;

    property AutoSelect       : Boolean               read FAutoSelect       write FAutoSelect;
    property CanEmpty         : Boolean               read FCanEmpty         write FCanEmpty;
    property Gengo            : Boolean               read FGengo            write SetGengo;
    property DisableColor     : TColor                read FDisableColor     write SetDisableColor;
    property DisableFontColor : TColor                read FDisableFontColor write SetDisableFontColor;
    property DropDownKey      : Boolean               read FDropDownKey      write FDropDownKey;
    property EnterNext        : Boolean               read FEnterNext        write FEnterNext;
    property ExitCheck        : Boolean               read FExitCheck        write FExitCheck;
    property DisplayError     : Boolean               read FDisplayError     write FDisplayError;
    property FocusedColor     : TColor                read FFocusedColor     write FFocusedColor;
    property DialogCaption    : String                read FDialogCaption    write FDialogCaption;
    property TabStop          : Boolean               read FTabStop          write SetControlTabStop;
    property Color            : TColor                read FColor            write SetControlColor;
    property OnKeyPress       : TKeyPressEvent        read FOnKeyPress       write FOnkeyPress;
    property OnKeyDown        : TKeyEvent             read FOnKeyDown        write FOnkeyDown;
    property OnChange         : TNotifyEvent          read FOnChange         write FOnChange;
    property OnClick          : TNotifyEvent          read FOnClick          write FOnClick;
  end;

  //f[^x[Xp
  TplDBDateEdit = class(TplDateEdit)
  private
    IsEdit : Boolean;
    FDataLink : TFieldDataLink;
    function GetDataField: string;
    function GetDataSource: TDataSource;
    function GetReadOnly: Boolean;
    procedure SetDataField(const Value: string);
    procedure SetDataSource(const Value: TDataSource);
    procedure SetReadOnly(const Value: Boolean);
    function FindField: TField;
    procedure EditKeyPress(Sender: TObject; var Key: Char); override;
    procedure EditKeyDown(Sender: TObject; var Key: Word;Shift: TShiftState); override;
    procedure EditChange(Sender: TObject); override;
  protected
    procedure DataChange(Sender: TObject); virtual;
    procedure UpdateData(Sender: TObject);
    procedure DoExit; override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property DataField: string read GetDataField write SetDataField;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property ReadOnly: Boolean read GetReadOnly write SetReadOnly;
  end;

procedure Register;

implementation

{$IF CompilerVersion > 14.99}
uses Themes, Math;
{$IFEND}

{ TplDateEdit}

//=============================================================================
//  R|[lg
//  ̃R|[lg̏Ɗ֌W鏉SetParentŎs.
//  ̃R|̂ɃtH[JXړ[Tab]̓Ȃǂ܂Ȃ̂Ō
//  TabStop=Falseɂ,ʂTabStop`.
//  Colorʒ`ɂĂ.͏xt̓t͗p̏̂ł
//  邪,\͖Ȃ̂Ŋ҂͂Ȃ悤.
//=============================================================================
constructor TplDateEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOWner);
    
  inherited TabStop := False;
  ParentColor       := True;
  FAutoSelect       := True;

  FErrorKinds := [];
end;

//=============================================================================
//  R|[lg̃[hI
//  ݂̂Ƃ͓ɏȂ
//=============================================================================
procedure TplDateEdit.Loaded;
begin
  inherited Loaded;
end;

//=============================================================================
//  R|[lgj
//  ݂̂Ƃ͓ɏȂ
//=============================================================================
destructor TplDateEdit.Destroy;
begin
  inherited Destroy;
end;

//=============================================================================
//  eRg[̐ƃR|vpeB̏
//
//  Rg[̈ʒuƍSetControlResizePosition\bhŐݒ
//  Rg[͈̐ԍ̌IR{
//
//  : tݒ肵Ȃ(SĂ̓̓Rg[̎)Ɏ擾ĺC
//        BaseDate1O̒lłD
//=============================================================================
procedure TplDateEdit.SetParent(AParent: TWinControl);
begin
  inherited;

  if AParent = nil then exit;

  if FGengoCombo=nil then begin
    //{R|̂Captionsv
    Caption := '';

    Canvas.Font := Font;
    FColor      := clWhite;
    //IR{{bNX̍쐬Ə
    FGengoCombo := TComboBox.Create(Self);
    CreateComboBox(FGengoCombo);
    //Ԃ͌IŔN,,D͂͂Ȃ
    FEditGengo := True;
    FEditAmpm  := False;
    FEditStyle := desYearMonthDay;

    //珇ԂɌ߂ĂȂ,Rg[̍ɂ킸̌ԂłĂ܂
    //t͕Ƃ̉Ẽx̍쐬
    FYearEdit   := TplDateEditEdit.Create(Self);
    FYearLabel  := TplDateEditLabel.Create(Self);
    FMonthEdit  := TplDateEditEdit.Create(Self);
    FMonthLabel := TplDateEditLabel.Create(Self);
    FDayEdit    := TplDateEditEdit.Create(Self);
    FDayLabel   := TplDateEditLabel.Create(Self);

    CreateEditBox(FYearEdit);
    CreateLabel  (FYearLabel,'N');
    CreateEditBox(FMonthEdit);
    CreateLabel  (FMonthLabel,'');
    CreateEditBox(FDayEdit);
    CreateLabel  (FDayLabel,'');

    //ߑOߌIR{{bNX̍쐬Ə
    FAmpmCombo := TComboBox.Create(Self);
    CreateComboBox(FAmpmCombo);

    //͕Ƃ̉Ẽx̍쐬
    FHourEdit    := TplDateEditEdit.Create(Self);
    FHourLabel   := TplDateEditLabel.Create(Self);
    FMinuteEdit  := TplDateEditEdit.Create(Self);
    FMinuteLabel := TplDateEditLabel.Create(Self);
    FSecondEdit  := TplDateEditEdit.Create(Self);
    FSecondLabel := TplDateEditLabel.Create(Self);

    CreateEditBox(FHourEdit);
    CreateLabel  (FHourLabel, '');
    CreateEditBox(FMinuteEdit);
    CreateLabel  (FMinuteLabel, '');
    CreateEditBox(FSecondEdit);
    CreateLabel  (FSecondLabel, 'b');

    //evpeB̏
{$IFDEF CONDITIONALEXPRESSIONS}
{$IF RTLVersion < 24.0}
    ShortDateFormat   := 'YYYY/MM/DD';
{$IFEND}
{$ENDIF}
    FBaseDate         := VarToDateTime('1873/01/01');
    FDate             := FBaseDate-1;
    FDateTime         := FDate;
    FCanEmpty         := True;
    FGengo            := True;
    FDisableColor     := clGray;
    FDisableFontColor := clWhite;
    FDropDownKey      := True;
    FIsEmpty          := True;
    FEnterNext        := True;
    FExitCheck        := False;
    FDisplayError     := True;
    FFocusedColor     := clAqua;

    FLabelYear        := FYearLabel.Text;
    FLabelMonth       := FMonthLabel.Text;
    FLabelDay         := FDayLabel.Text;
    FLabelHour        := FHourLabel.Text;
    FLabelMinute      := FMinuteLabel.Text;
    FLabelSecond      := FSecondLabel.Text;

    FDialogCaption  := 't';
    FTabStop        := True;
    FYeardigit      := yddigit4;
    FSpaceWidth     := 7;

    //eRg[̕ƈʒuݒ肵ĕ\
    SetControlResizePosition(True);
  end;
end;

{$IFDEF CONDITIONALEXPRESSIONS}
{$IF RTLVersion >= 24.0}
class constructor TplDateEdit.Create;
{$IF RTLVersion >= 26.0}
var
  I: Integer;
{$IFEND}
begin
  FFormatSettings := TFormatSettings.Create;
  FFormatSettings.ShortDateFormat := 'YYYY/MM/DD';
{$IF RTLVersion >= 26.0}
  MaxEraCount := Length(FormatSettings.EraInfo);
  SetLength(EraNames, MaxEraCount + 1);
  SetLength(EraYearOffsets, MaxEraCount + 1);
  for I := 0 to MaxEraCount - 1 do
  begin
    EraNames[I + 1] := FormatSettings.EraInfo[I].EraName;
    EraYearOffsets[I + 1] := FormatSettings.EraInfo[I].EraOffset;
  end;
{$IFEND}
end;
{$IFEND}
{$ENDIF}

//=============================================================================
//  IpR{{bNX̐Ə
//=============================================================================
procedure TplDateEdit.CreateComboBox(ACombo: TComboBox);
var
  i : Integer;
begin
  with ACombo do begin
    Parent      := Self;
    ParentFont  := False;
    Left        := 0;
    Style       := csOwnerDrawFixed;
    ImeMode     := imDisable;
    OnEnter     := EditEnter;
    OnExit      := EditExit;
    OnKeyPress  := EditKeyPress;
    OnKeyDown   := EditKeyDown;
    OnDropDown  := GengoDropDown;
    OnDrawItem  := GengoDrawItem;
    OnChange    := EditChange;
    OnClick     := EditClick;

    Items.Clear;
    if ACombo = FGengoCombo then begin
      //IItem̍쐬
      Items.Add('');
      for i := 1 to MaxEraCount do begin
        if EraNames[i]='' then break;
        Items.Add(EraNames[i]);
      end;
    end else begin
      //ߑOߌIItem̍쐬
      //'ߑO','ߌ'̖O͗ႦAM,PMɂĂ悢
      //ItemIndex=0͌ߑOCItemIndex=1͌ߌƂď
      Items.Add('ߑO');
      Items.Add('ߌ');
    end;
    DefHeightItemHeightCombo := Height - ItemHeight;
  end;
end;

//=============================================================================
//  ͗̃Rg[̐Ə
//  TEditł͂ȂTMemo(NXtplDateEditEdidɕύX)1s̃Gfbg{bNX
//  Ƃėp
//  (E񂹂Ɠ͕̐ݒ肪ȒPȂ̂)
//=============================================================================
procedure TplDateEdit.CreateEditBox(AMemo: TplDateEditEdit);
begin
  with AMemo do begin
    Parent      := Self;
    ParentFont  := False;
    WantReturns := False;
    WantTabs    := False;
    WordWrap    := False;
    Alignment   := taRightJustify;
    ImeMode     := imDisable;
    Color       := FColor;
    OnEnter     := EditEnter;
    OnExit      := EditExit;
    OnKeyPress  := EditKeyPress;
    OnKeyDown   := EditKeyDown;
    OnChange    := EditChange;
    OnClick     := EditClick;
    MaxLength   := 2;
  end;
end;

//=============================================================================
//  ͗̉E[N][][][][][b]̃xp̃xRg[
//  TPanelō쐬,XPe[}Ɖ[ɂȂĂ܂
//  ŋ}TCustomControl쐬ɕύX(Ver1.1)
//=============================================================================
procedure TplDateEdit.CreateLabel(ALabel: TplDateEditLabel; AText:String );
begin
  with ALabel do begin
    Parent       := Self;
    ParentFont   := False;
    ParentColor  := False;
    Color        := $00E4E4E4;
    Text         := AText;
    Font.Size    := Canvas.Font.Size;
    TabStop      := False;
    ControlStyle := ALabel.ControlStyle - [csAcceptsControls];
    FplDate      := Self;
  end;
end;

//=============================================================================
//  \Rg[̐ݒ
//  EditStylevpeBp
//  ݂̒l̓Zbg
//=============================================================================
procedure TplDateEdit.SetEditStyle(const Value: TplDateEditStyle);
begin
  if FEditStyle <> Value then begin
    FEditStyle := Value;
    if (csReading in ComponentState) then exit;
    SetControlResizePosition(True);
  end;
end;

//=============================================================================
//  ̓R{{bNX̕\\̐ݒ
//  EditGengo(Boolean)vpeBp
//  \̎͐͂Ɖ߂,a\sɂ
//=============================================================================
procedure TplDateEdit.SetEditGengo(const Value: Boolean);
begin
  if FEditGengo <> Value then begin
    if Value = False then begin
      FEditGengo := False;
      FGengo     := False;
    end else begin
      FEditGengo := True;
    end;
    //TplDateEditVer2.10ŏC
    SetControlResizePosition(False);
    if (csReading in ComponentState) then exit;
    GetProperties;
  end;
end;

//=============================================================================
//  ߑOߌI̓R{{bNX̕\\̐ݒ
//  EditAmpm(Boolean)vpeBp
//  \̎24ԕ\Ɖ߂
//=============================================================================
procedure TplDateEdit.SetEditAmpm(const Value: Boolean);
begin
  if FEditAmpm <> Value then begin
    if Value = False then begin
      FEditAmpm := False;
    end else begin
      FEditAmpm := True;
    end;
    //TplDateEditVer2.10ŏC
    SetControlResizePosition(False);
    if (csReading in ComponentState) then exit;
    GetProperties;
  end;
end;

//=============================================================================
//  N,,,,,b̃x(e͗̉Ẽx)̕ύX
//=============================================================================
procedure TplDateEdit.SetLabelCaption(const Index: Integer; const Value: String);
begin
  case Index of
    1:
    begin
      FYearLabel.Text := Value;
      FLabelYear      := Value;
    end;
    2:
    begin
      FMonthLabel.Text := Value;
      FLabelMonth      := Value;
    end;
    3:
    begin
      FDayLabel.Text := Value;
      FLabelDay      := Value;
    end;
    4:
    begin
      FHourLabel.Text := Value;
      FLabelHour      := Value
    end;
    5:
    begin
      FMinuteLabel.Text := Value;
      FLabelMinute      := Value;
    end;
    6:
    begin
      FSecondLabel.Text := Value;
      FLabelSecond      := Value;
    end;
  end;
  SetControlResizePosition(False);
end;

//=============================================================================
//  tƎ̓Rg[̃Xy[X SpaceWidth
//  ̒l𕉂ɂƎ֌W̃Rg[͉ɔzu
//=============================================================================
procedure TplDateEdit.SetSpaceWidth(const Value: Integer);
begin
  if FSpaceWidth <> Value then begin
    FSpaceWidth := Value;
    SetControlResizePosition(False);
  end;
end;

//=============================================================================
//  ̕\̐ݒ
//  yddigit2 2
//  yddigit4 4
//=============================================================================
procedure TplDateEdit.SetYeardigit(const Value: TplYeardigitSet);
begin
  if FYeardigit <> Value then begin
    FYeardigit := Value;
    SetControlResizePosition(False);
    GetProperties;
  end;
end;

//=============================================================================
//  \Rg[(I,NCɉ)\ƈʒu̐ݒ͑S
//  ̃\bhōs悤ɂĂ.\ȂRg[̕0Ŕ\
//=============================================================================
procedure TplDateEdit.SetControlResizePosition(EmptyFlag:Boolean=True);
var
  ALeft            : Integer;
  AHeight          : Integer;
  ATop             : Integer;
  WidthA           : Integer;
  WidthB           : Integer;
  SysMetrics       : TTextMetric;
  Metrics          : TTextMetric;
  I                : Integer;
  LeftPosMargin    : Integer;
  ComboLeftMargein : Integer;
begin
  if FGengoCombo=nil then exit;

  if CheckWin32Version(6, 0) then begin
    LeftPosMargin := 0;
  end else begin
    LeftPosMargin := 3;
  end;

  fgResize := True;

  Canvas.Font.Assign(Font);
  GetTextMetrics(Canvas.Handle,Metrics);
  I := GetSystemMetrics(SM_CYBORDER) * 8;

  //̃R|̍(SpaceWidht<0͕̎ω)
  SingleHeight := Metrics.tmHeight + I;
  Height       := SingleHeight;

  //U͗SċɂĎ̓Rg[̕\\ɉ
  //lZbg
  if EmptyFlag then SetEditEmpty;

  {$IF CompilerVersion > 14.99}
  if ThemeServices.ThemesEnabled then begin
    ComboLeftMargein := 0;
  end else begin
    ComboLeftMargein := 3;
  end;
  {$ELSE}
  ComboLeftMargein := 3;
  {$IFEND}

  //X璷ł邪X^CƂɐݒ
  ALeft := 0;
  ATop  := 0;
  case FEditStyle of

    //Nb
    desYearMonthDayHMS:
    begin
      if FSpaceWidth < 0 then begin
        ATop   := SingleHeight - FSpaceWidth;
        Height := SingleHeight * 2 - FSpaceWidth;
      end;
      ControlShowHide (FGengoCombo,  0, SingleHeight, FEditGengo);
      if FEditGengo then ALeft := FGengoCombo.Width - ComboLeftMargein;

      ControlShowHide (FYearEdit,    0,    SingleHeight, True);
      ControlShowHide (FMonthEdit,   0,    SingleHeight, True);
      ControlShowHide (FDayEdit,     0,    SingleHeight, True);
      ControlShowHide (FYearLabel,   0,    SingleHeight, True);
      ControlShowHide (FMonthLabel,  0,    SingleHeight, True);
      ControlShowHide (FDayLabel,    0,    SingleHeight, True);
      ControlShowHide (FHourEdit,    ATop, SingleHeight, True);
      ControlShowHide (FMinuteEdit,  ATop, SingleHeight, True);
      ControlShowHide (FSecondEdit,  ATop, SingleHeight, True);
      ControlShowHide (FHourLabel,   ATop, SingleHeight, True);
      ControlShowHide (FMinuteLabel, ATop, SingleHeight, True);
      ControlShowHide (FSecondLabel, ATop, SingleHeight, True);

      FYearEdit.Left   := ALeft;
      FYearLabel.Left  := FYearEdit.Left   + FYearEdit.Width;
      FMonthEdit.Left  := FYearLabel.Left  + FYearLabel.Width - LeftPosMargin;
      FMonthLabel.Left := FMonthEdit.Left  + FMonthEdit.Width;
      FDayEdit.Left    := FMonthLabel.Left + FMonthLabel.Width - LeftPosMargin;
      FDayLabel.Left   := FDayEdit.Left    + FDayEdit.Width;
      WidthA           := FDayLabel.Left   + FDayLabel.Width;

      ControlShowHide (FAmpmCombo, ATop, SingleHeight, FEditAmpm);
      if FSpaceWidth >= 0 then ALeft := WidthA+SpaceWidth else ALeft := 0;
      if FEditAmpm then begin
        FAmpmCombo.Left := ALeft;
        ALeft := FAmpmCombo.Left + FAmpmCombo.Width - ComboLeftMargein;
      end;
      FHourEdit.Left    := ALeft;
      FHourLabel.Left   := FHourEdit.Left    + FHourEdit.Width;
      FMinuteEdit.Left  := FHourLabel.Left   + FHourLabel.Width - LeftPosMargin;
      FMinuteLabel.Left := FMinuteEdit.Left  + FMinuteEdit.Width;
      FSecondEdit.Left  := FMinuteLabel.Left + FMinuteLabel.Width - LeftPosMargin;
      FSecondLabel.Left := FSecondEdit.Left  + FSecondEdit.Width;
      WidthB            := FSecondLabel.Left + FSecondLabel.Width;

      if WidthA > WidthB then Width  := WidthA else Width := WidthB;
      if FSpaceWidth < 0 then Height := SingleHeight * 2 - FSpaceWidth;
    end;

    //N
    desYearMonthDayHM:
    begin
      if FSpaceWidth < 0 then begin
        ATop   := SingleHeight - FSpaceWidth;
        Height := SingleHeight * 2 - FSpaceWidth;
      end;
      ControlShowHide (FGengoCombo, 0, SingleHeight, FEditGengo);
      if FEditGengo then ALeft := FGengoCombo.Width - ComboLeftMargein;

      ControlShowHide (FYearEdit,    0,    SingleHeight, True);
      ControlShowHide (FMonthEdit,   0,    SingleHeight, True);
      ControlShowHide (FDayEdit,     0,    SingleHeight, True);
      ControlShowHide (FYearLabel,   0,    SingleHeight, True);
      ControlShowHide (FMonthLabel,  0,    SingleHeight, True);
      ControlShowHide (FDayLabel,    0,    SingleHeight, True);
      ControlShowHide (FHourEdit,    ATop, SingleHeight, True);
      ControlShowHide (FMinuteEdit,  ATop, SingleHeight, True);
      ControlShowHide (FSecondEdit,  ATop, SingleHeight, False);
      ControlShowHide (FHourLabel,   ATop, SingleHeight, True);
      ControlShowHide (FMinuteLabel, ATop, SingleHeight, True);
      ControlShowHide (FSecondLabel, ATop, SingleHeight, False);

      FYearEdit.Left   := ALeft;
      FYearLabel.Left  := FYearEdit.Left   + FYearEdit.Width;
      FMonthEdit.Left  := FYearLabel.Left  + FYearLabel.Width - LeftPosMargin;
      FMonthLabel.Left := FMonthEdit.Left  + FMonthEdit.Width;
      FDayEdit.Left    := FMonthLabel.Left + FMonthLabel.Width - LeftPosMargin;
      FDayLabel.Left   := FDayEdit.Left    + FDayEdit.Width;
      WidthA           := FDayLabel.Left   + FDayLabel.Width;

      ControlShowHide (FAmpmCombo, ATop, SingleHeight, FEditAmpm);
      if FSpaceWidth >= 0 then ALeft := WidthA + FSpaceWidth else ALeft := 0;
      if FEditAmpm then begin
        FAmpmCombo.Left := ALeft;
        ALeft := FAmpmCombo.Left + FAmpmCombo.Width - ComboLeftMargein;
      end;
      FHourEdit.Left    := ALeft;
      FHourLabel.Left   := FHourEdit.Left    + FHourEdit.Width;
      FMinuteEdit.Left  := FHourLabel.Left   + FHourLabel.Width - LeftPosMargin;
      FMinuteLabel.Left := FMinuteEdit.Left  + FMinuteEdit.Width;
      WidthB            := FMinuteLabel.Left + FMinuteLabel.Width;

      if WidthA > WidthB then Width  := WidthA else Width := WidthB;
      if FSpaceWidth < 0 then Height := SingleHeight * 2 - FSpaceWidth;
    end;

    //N
    desYearMonthDayH:
    begin
      if FSpaceWidth < 0 then begin
        ATop   := SingleHeight-FSpaceWidth;
        Height := SingleHeight*2-FSpaceWidth;
      end;
      ControlShowHide (FGengoCombo, 0, SingleHeight, FEditGengo);
      if FEditGengo then ALeft := FGengoCombo.Width - ComboLeftMargein;

      ControlShowHide (FYearEdit,    0,    SingleHeight, True);
      ControlShowHide (FMonthEdit,   0,    SingleHeight, True);
      ControlShowHide (FDayEdit,     0,    SingleHeight, True);
      ControlShowHide (FYearLabel,   0,    SingleHeight, True);
      ControlShowHide (FMonthLabel,  0,    SingleHeight, True);
      ControlShowHide (FDayLabel,    0,    SingleHeight, True);
      ControlShowHide (FHourEdit,    ATop, SingleHeight, True);
      ControlShowHide (FMinuteEdit,  ATop, SingleHeight, False);
      ControlShowHide (FSecondEdit,  ATop, SingleHeight, False);
      ControlShowHide (FHourLabel,   ATop, SingleHeight, True);
      ControlShowHide (FMinuteLabel, ATop, SingleHeight, False);
      ControlShowHide (FSecondLabel, ATop, SingleHeight, False);

      FYearEdit.Left   := ALeft;
      FYearLabel.Left  := FYearEdit.Left   + FYearEdit.Width;
      FMonthEdit.Left  := FYearLabel.Left  + FYearLabel.Width - LeftPosMargin;
      FMonthLabel.Left := FMonthEdit.Left  + FMonthEdit.Width;
      FDayEdit.Left    := FMonthLabel.Left + FMonthLabel.Width - LeftPosMargin;
      FDayLabel.Left   := FDayEdit.Left+FDayEdit.Width;
      WidthA           := FDayLabel.Left+FDayLabel.Width;

      ControlShowHide (FAmpmCombo,ATop, SingleHeight, FEditAmpm);
      if FSpaceWidth >= 0 then ALeft := WidthA+FSpaceWidth else ALeft := 0;
      if FEditAmpm then begin
        FAmpmCombo.Left := ALeft;
        ALeft := FAmpmCombo.Left + FAmpmCombo.Width - ComboLeftMargein;
      end;
      FHourEdit.Left    := ALeft;
      FHourLabel.Left   := FHourEdit.Left+FHourEdit.Width;;
      WidthB            := FHourLabel.Left+FHourLabel.Width;

      if WidthA > WidthB then Width  := WidthA else Width := WidthB;
      if FSpaceWidth < 0 then Height := SingleHeight * 2 - FSpaceWidth;
    end;

    //N
    desYearMonthDay:
    begin
      ControlShowHide (FGengoCombo, 0, SingleHeight, FEditGengo);
      if FEditGengo then ALeft := FGengoCombo.Width - ComboLeftMargein;

      ControlShowHide (FAmpmCombo,   0,    SingleHeight, False);
      ControlShowHide (FYearEdit,    0,    SingleHeight, True);
      ControlShowHide (FMonthEdit,   0,    SingleHeight, True);
      ControlShowHide (FDayEdit,     0,    SingleHeight, True);
      ControlShowHide (FYearLabel,   0,    SingleHeight, True);
      ControlShowHide (FMonthLabel,  0,    SingleHeight, True);
      ControlShowHide (FDayLabel,    0,    SingleHeight, True);
      ControlShowHide (FHourEdit,    ATop, SingleHeight, False);
      ControlShowHide (FMinuteEdit,  ATop, SingleHeight, False);
      ControlShowHide (FSecondEdit,  ATop, SingleHeight, False);
      ControlShowHide (FHourLabel,   ATop, SingleHeight, False);
      ControlShowHide (FMinuteLabel, ATop, SingleHeight, False);
      ControlShowHide (FSecondLabel, ATop, SingleHeight, False);

      FYearEdit.Left   := ALeft;
      FYearLabel.Left  := FYearEdit.Left   + FYearEdit.Width;//2;
      FMonthEdit.Left  := FYearLabel.Left  + FYearLabel.Width - LeftPosMargin;
      FMonthLabel.Left := FMonthEdit.Left  + FMonthEdit.Width;//2;
      FDayEdit.Left    := FMonthLabel.Left + FMonthLabel.Width - LeftPosMargin;
      FDayLabel.Left   := FDayEdit.Left    + FDayEdit.Width;//2;
      Width            := FDayLabel.Left   + FDayLabel.Width;
    end;

    //N
    desYearMonth:
    begin
      FDayEdit.Text := '1';
      ControlShowHide (FGengoCombo, 0, SingleHeight, FEditGengo);
      if FEditGengo then ALeft := FGengoCombo.Width - ComboLeftMargein;

      ControlShowHide (FAmpmCombo,   0,    SingleHeight, False);
      ControlShowHide (FYearEdit,    0,    SingleHeight, True);
      ControlShowHide (FMonthEdit,   0,    SingleHeight, True);
      ControlShowHide (FDayEdit,     0,    SingleHeight, False);
      ControlShowHide (FYearLabel,   0,    SingleHeight, True);
      ControlShowHide (FMonthLabel,  0,    SingleHeight, True);
      ControlShowHide (FDayLabel,    0,    SingleHeight, False);
      ControlShowHide (FHourEdit,    ATop, SingleHeight, False);
      ControlShowHide (FMinuteEdit,  ATop, SingleHeight, False);
      ControlShowHide (FSecondEdit,  ATop, SingleHeight, False);
      ControlShowHide (FHourLabel,   ATop, SingleHeight, False);
      ControlShowHide (FMinuteLabel, ATop, SingleHeight, False);
      ControlShowHide (FSecondLabel, ATop, SingleHeight, False);

      FYearEdit.Left   := ALeft;
      FYearLabel.Left  := FYearEdit.Left   + FYearEdit.Width - 2;
      FMonthEdit.Left  := FYearLabel.Left  + FYearLabel.Width - LeftPosMargin;
      FMonthLabel.Left := FMonthEdit.Left  + FMonthEdit.Width - 2;
      Width            := FMonthLabel.Left + FMonthLabel.Width;
    end;

    //N
    desYear:
    begin
      FMonthEdit.Text := '1';
      FDayEdit.Text   := '1';
      ControlShowHide (FGengoCombo, 0, SingleHeight, FEditGengo);
      if FEditGengo then ALeft := FGengoCombo.Width - ComboLeftMargein;

      ControlShowHide (FAmpmCombo,   ATop, SingleHeight, False);
      ControlShowHide (FYearEdit,    0,    SingleHeight, True);
      ControlShowHide (FMonthEdit,   0,    SingleHeight, False);
      ControlShowHide (FDayEdit,     ATop, SingleHeight, False);
      ControlShowHide (FYearLabel,   ATop, SingleHeight, True);
      ControlShowHide (FMonthLabel,  ATop, SingleHeight, False);
      ControlShowHide (FDayLabel,    ATop, SingleHeight, False);
      ControlShowHide (FHourEdit,    ATop, SingleHeight, False);
      ControlShowHide (FMinuteEdit,  ATop, SingleHeight, False);
      ControlShowHide (FSecondEdit,  ATop, SingleHeight, False);
      ControlShowHide (FHourLabel,   ATop, SingleHeight, False);
      ControlShowHide (FMinuteLabel, ATop, SingleHeight, False);
      ControlShowHide (FSecondLabel, ATop, SingleHeight, False);

      FYearEdit.Left  := ALeft;
      FYearLabel.Left := FYearEdit.Left  + FYearEdit.Width - 2;
      Width           := FYearLabel.Left + FYearLabel.Width;
    end;

    //b
    desHourMinuteSecond:
    begin
      ControlShowHide (FGengoCombo,  0, SingleHeight, False);
      ControlShowHide (FYearEdit,    0, SingleHeight, False);
      ControlShowHide (FMonthEdit,   0, SingleHeight, False);
      ControlShowHide (FDayEdit,     0, SingleHeight, False);
      ControlShowHide (FYearLabel,   0, SingleHeight, False);
      ControlShowHide (FMonthLabel,  0, SingleHeight, False);
      ControlShowHide (FDayLabel,    0, SingleHeight, False);
      ControlShowHide (FHourEdit,    0, SingleHeight, True);
      ControlShowHide (FMinuteEdit,  0, SingleHeight, True);
      ControlShowHide (FSecondEdit,  0, SingleHeight, True);
      ControlShowHide (FHourLabel,   0, SingleHeight, True);
      ControlShowHide (FMinuteLabel, 0, SingleHeight, True);
      ControlShowHide (FSecondLabel, 0, SingleHeight, True);

      ControlShowHide (FAmpmCombo, 0, SingleHeight,FEditAmpm);
      if FEditAmpm then ALeft := FAmpmCombo.Left + FAmpmCombo.Width - ComboLeftMargein;

      FHourEdit.Left    := ALeft;
      FHourLabel.Left   := FHourEdit.Left    + FHourEdit.Width;
      FMinuteEdit.Left  := FHourLabel.Left   + FHourLabel.Width - LeftPosMargin;
      FMinuteLabel.Left := FMinuteEdit.Left  + FMinuteEdit.Width;
      FSecondEdit.Left  := FMinuteLabel.Left + FMinuteLabel.Width - LeftPosMargin;
      FSecondLabel.Left := FSecondEdit.Left  + FSecondEdit.Width;
      Width             := FSecondLabel.Left + FSecondLabel.Width;
    end;

    //
    desHourMinute:
    begin
      ControlShowHide (FGengoCombo,  0, SingleHeight, False);
      ControlShowHide (FYearEdit,    0, SingleHeight, False);
      ControlShowHide (FMonthEdit,   0, SingleHeight, False);
      ControlShowHide (FDayEdit,     0, SingleHeight, False);
      ControlShowHide (FYearLabel,   0, SingleHeight, False);
      ControlShowHide (FMonthLabel,  0, SingleHeight, False);
      ControlShowHide (FDayLabel,    0, SingleHeight, False);
      ControlShowHide (FHourEdit,    0, SingleHeight, True);
      ControlShowHide (FMinuteEdit,  0, SingleHeight, True);
      ControlShowHide (FSecondEdit,  0, SingleHeight, False);
      ControlShowHide (FHourLabel,   0, SingleHeight, True);
      ControlShowHide (FMinuteLabel, 0, SingleHeight, True);
      ControlShowHide (FSecondLabel, 0, SingleHeight, False);

      ControlShowHide (FAmpmCombo, 0, SingleHeight, FEditAmpm);
      if FEditAmpm then ALeft := FAmpmCombo.Left + FAmpmCombo.Width - ComboLeftMargein;

      FHourEdit.Left    := ALeft;
      FHourLabel.Left   := FHourEdit.Left    + FHourEdit.Width;
      FMinuteEdit.Left  := FHourLabel.Left   + FHourLabel.Width - LeftPosMargin;
      FMinuteLabel.Left := FMinuteEdit.Left  + FMinuteEdit.Width;
      Width             := FMinuteLabel.Left + FMinuteLabel.Width;
    end;

    //
    desHour:
    begin
      ControlShowHide (FGengoCombo,  0, SingleHeight, False);
      ControlShowHide (FYearEdit,    0, SingleHeight, False);
      ControlShowHide (FMonthEdit,   0, SingleHeight, False);
      ControlShowHide (FDayEdit,     0, SingleHeight, False);
      ControlShowHide (FYearLabel,   0, SingleHeight, False);
      ControlShowHide (FMonthLabel,  0, SingleHeight, False);
      ControlShowHide (FDayLabel,    0, SingleHeight, False);
      ControlShowHide (FHourEdit,    0, SingleHeight, True);
      ControlShowHide (FMinuteEdit,  0, SingleHeight, False);
      ControlShowHide (FSecondEdit,  0, SingleHeight, False);
      ControlShowHide (FHourLabel,   0, SingleHeight, True);
      ControlShowHide (FMinuteLabel, 0, SingleHeight, False);
      ControlShowHide (FSecondLabel, 0, SingleHeight, False);

      ControlShowHide (FAmpmCombo, 0, SingleHeight, FEditAmpm);
      if FEditAmpm then ALeft := FAmpmCombo.Left + FAmpmCombo.Width - ComboLeftMargein;

      FHourEdit.Left  := ALeft;
      FHourLabel.Left := FHourEdit.Left  + FHourEdit.Width;
      Width           := FHourLabel.Left + FHourLabel.Width;
    end;
  end;
  //TCY̒IÕTCY֎~
  fgResize := False;
end;

//=============================================================================
//  eRg[̕\\
//  ComboBoxHeightŐݒ肵ĂDHeightFont.SizeŎŌ܂
//  ComboBox̍ItemHeightŐݒ肷
//  ItemHeight̐ݒ́CStyleOwnerȂƂłȂ
//=============================================================================
procedure TplDateEdit.ControlShowHide(Sender : TObject; ATop,AHeight: Integer;
  AFlag: Boolean);
var
  S           : String;
  WidthMargin : Integer;
begin
  if AFlag then begin
    if CheckWin32Version(6, 0) then begin
      WidthMargin := 2;
    end else begin
      WidthMargin := 0;
    end;

    TControl(Sender).Top     := ATop;
    TControl(Sender).Visible := True;

    if Sender is TComboBox then begin
      TComboBox(Sender).ItemHeight := AHeight - DefHeightItemHeightCombo;
      TComboBox(Sender).Font.Size  := Canvas.Font.Size;
      TComboBox(Sender).Font.Color := Canvas.Font.Color;

      {$IF CompilerVersion > 14.99}
      if ThemeServices.ThemesEnabled then begin
        TComboBox(Sender).Width := Canvas.TextWidth('0000') + 27; //24
      end else begin
        TComboBox(Sender).Width := Canvas.TextWidth('0000') + 27;
      end;
      {$ELSE}
      TComboBox(Sender).Width := Canvas.TextWidth('0000') + 27;
      {$IFEND}
    end;

    if Sender is TplDateEditEdit then begin
      TplDateEditEdit(Sender).Height    := AHeight;
      TplDateEditEdit(Sender).Font      := Canvas.Font;
      TplDateEditEdit(Sender).Font.Size := Canvas.Font.Size;

      if (Sender = FYearEdit) and (FYeardigit = yddigit4) then begin
        TplDateEditEdit(Sender).MaxLength := 4;
        TplDateEditEdit(Sender).Width     := Canvas.TextWidth('0000') + 12;
      end else begin
        TplDateEditEdit(Sender).MaxLength := 2;
        TplDateEditEdit(Sender).Width     := Canvas.TextWidth('00') + 12;
      end;
    end;

    if Sender is TplDateEditLabel then begin
      S := TplDateEditLabel(Sender).Text;

      TplDateEditLabel(Sender).Height     := AHeight;
      TplDateEditLabel(Sender).Width      := Canvas.TextWidth(S) + 10 - WidthMargin;
      TplDateEditLabel(Sender).Font.Size  := Canvas.Font.Size;
      TplDateEditLabel(Sender).Font.Style := [];
      TplDateEditLabel(Sender).Font.Color := clBlack;
    end;
  end else begin
    TControl(Sender).Width   := 0;
    TControl(Sender).Visible := False;
  end;
end;

{ TplDateEditLabel }

//=============================================================================
//  Nb̃x̕`
//  Ver1.1Œǉ
//=============================================================================
procedure TplDateEditLabel.Paint;
var
  ARect    : TRect;
  AEge     : UINT;
  AGrfFlag : UINT;
  uFormat  : UINT;
begin
  inherited;
  if FplDate = nil then exit;

  //x̘g̃GbWނ`.XPe[}̏ꍇ̓tbgȘg
  //OSWindows XPł}jtFXgw肳Ăꍇ
  {$IF CompilerVersion > 14.99}
  if ThemeServices.ThemesEnabled then begin
    AEge     := BDR_RAISEDOUTER;
    AGrfFlag := BF_FLAT or BF_RECT;
  end else begin
    AEge     := EDGE_SUNKEN;
    AGrfFlag := BF_RECT;
  end;
  {$ELSE}
  AEge     := EDGE_SUNKEN;
  AGrfFlag := BF_RECT;
  {$IFEND}

  //tHgTCY
  Canvas.Font.Assign(Font);

  //`̃ACg.1ŝ.㉺E
  uFormat := DT_SINGLELINE or DT_CENTER or DT_VCENTER;
  //xgƕ`
  ARect := ClientRect;
  DrawEdge(Canvas.Handle, ARect, AEge, AGrfFlag);
  SetBkMode(Canvas.Handle, TRANSPARENT);
  DrawText(Canvas.Handle, PChar(Text), -1, ARect, uFormat);
end;

{ TplDateEdit }

//=============================================================================
//  ͗Sċɂ
//=============================================================================
procedure TplDateEdit.SetEditEmpty;
begin
  FYear         := 0;
  FMonth        := 0;
  FDay          := 0;
  FHour         := 0;
  FMinute       := 0;
  FSecond       := 0;
  FYearStr      := '';
  FMonthStr     := '';
  FDayStr       := '';
  FHourStr      := '';
  FMinuteStr    := '';
  FSecondStr    := '';
  FGengoYear    := 0;
  FGengoYearStr := '';
  FGengoStr     := '';
  FAmpmStr      := '';

  FGengoCombo.ItemIndex := -1; //FGengoCombo.Text:='';
  FAmpmCombo.ItemIndex  := -1; //FGengoCombo.Text:='';
  FDateTime             := FBaseDate - 1;
  FDate                 := FDateTime;
  FYearEdit.Text        := '';
  FMonthEdit.Text       := '';
  FDayEdit.Text         := '';
  FHourEdit.Text        := '';
  FMinuteEdit.Text      := '';
  FSecondEdit.Text      := '';
  FIsEmpty              := True;
end;

//=============================================================================
//  DateTime^̒lR|̊eRg[ɕ\
//  t⎞O^̏
//  FDatevpeB͑Õo[WƂ̌݊̂
//
//  tƎ͕\̎TDateTimeɓtƎL^
//  t͕̓\̎TDateTimeɓt̂݋L^
//  o͕̓\̎TDateTimeɎ̂݋L^
//  tTDateTime̐
//  TDateTimȅ_
//=============================================================================
procedure TplDateEdit.SetDate(const Value: TDateTime);
const
  ErrorS1 = 'Ȃt^̒lZbg܂D@@';
begin
  if csReading in ComponentState then exit;
  FErrorKinds := [];

  if FDateTime <> Value then begin
    try
      if (FYearEdit.Visible) and (FHourEdit.Visible) then begin
        FDateTime := Value;
      end else
      if (FYearEdit.Visible) then begin
        FDateTime := Trunc(Value);
      end else begin
        FDateTime := Frac(Value);
      end;
      FDate := FDateTime;
      //G[ȂΊevpeBlRg[ɕ\
      GetProperties;
    except
      FErrorKinds := [derSetDateTimeError];
      ShowErrorDialog(ErrorS1, nil);
    end;
  end;
end;

//=============================================================================
//  a\
//  IXg\̎͘a\͂Ȃ
//=============================================================================
procedure TplDateEdit.SetGengo(const Value: Boolean);
begin
  if FGengo <> Value then begin
    if FEditGengo then begin
      FGengo := Value;
    end else begin
      FGengo  := False;
    end;
    if (csReading in ComponentState) then exit;
    if (csDesigning in ComponentState) then exit;
    CheckDateError;
  end;
end;

//=============================================================================
//  DateTime,Date,TimevpeB̎擾\bh
//=============================================================================
function TplDateEdit.GetDate: TDateTime;
begin
  Result := 0;
  if (csDesigning in ComponentState) then exit;
  if (csReading in ComponentState) then exit;
  if CheckDateError = False then begin
    Result := FDateTime;
  end;
end;

//=============================================================================
//  eRg[̓͒l()DateTime^̓tvZ
//  G[̎True
//  l: FBaseDate := StrToDateTime('1873/01/01');
//=============================================================================
function TplDateEdit.CheckDateError: Boolean;
const
  ErrorS2 = '1873N11(6N11)O̓t͏ł܂D@@';
  ErrorS3 = 't܂D@@';
  ErrorS4 = '܂D@@';
  ErrorS5 = '͗Sċ󔒂łD@@';
  ErrorS6 = '󔒂̓͗܂D@@';
  ErrorS7 = '2088N(100N)ȍ~͌ɕϊł܂D@@';
  ErrorS8 = 't܂͎܂D@@';
  ErrorS9 = '͉̓\Ȓl115959b܂łłD@@';
  ErrorS10= '͉̓\Ȓl235959b܂łłD@@';
  ErrorS11= 'tɕϊłȂlł.@@@';
var
  StrGengo    : String;
  StrAmpm     : String;
  dYear       : WORD;
  dMonth      : WORD;
  dDay        : WORD;
  dHour       : WORD;
  dMinute     : WORD;
  dSecond     : WORD;
  FlagGengo   : Boolean;
  FlagAmpm    : Boolean;
  FlagYear    : Boolean;
  FlagMonth   : Boolean;
  FlagDay     : Boolean;
  FlagHour    : Boolean;
  FlagMinute  : Boolean;
  FlagSecond  : Boolean;
  AWinControl : TWinControl;

  dMiri     : WORD;
  StrYear   : String;
  StrMonth  : String;
  StrDay    : String;
  StrHour   : String;
  StrMinute : String;
  StrSecond : String;
  i         : Integer;
  AIndex    : Integer;
  ADate     : TDateTime;
  ATime     : TDateTime;
begin
  Result      := True;
  FErrorKinds := [];

  if EditGengo = False then FGengoCombo.ItemIndex := -1;

  StrGengo  := Trim(FGengoCombo.Text);
  StrAmpm   := Trim(FAmpmCombo.Text);
  StrYear   := Trim(FYearEdit.Text);
  StrMonth  := Trim(FMonthEdit.Text);
  StrDay    := Trim(FDayEdit.Text);
  StrHour   := Trim(FHourEdit.Text);
  StrMinute := Trim(FMinuteEdit.Text);
  StrSecond := Trim(FSecondEdit.Text);

  FlagGengo  := (StrGengo  = '' )   and FGengoCombo.Visible;
  FlagAmpm   := (StrAmpm   = ''  )  and FAmpmCombo.Visible;
  FlagYear   := (StrYear   = ''  )  and FYearEdit.Visible;
  FlagMonth  := (StrMonth  = '' )   and FMonthEdit.Visible;
  FlagDay    := (StrDay    = ''   ) and FDayEdit.Visible;
  FlagHour   := (StrHour   = ''  )  and FHourEdit.Visible;
  FlagMinute := (StrMinute = '')    and FMinuteEdit.Visible;
  FlagSecond := (StrSecond = '')    and FSecondEdit.Visible;

  //͗Sċ󔒂̏ꍇ
  if GetIsEmpty then begin
    FIsEmpty := True;
    //󔒓͂ĂȂꍇ
    if FCanEmpty = False then begin
      FErrorKinds := [derAllEmpty];
      ShowErrorDialog(ErrorS5, nil);
    end else begin
      //t֌W̎擾vpeBlɂăG[ȂŏI
      SetEditEmpty;
      Result := False;
      exit;
    end;
  //ǂꂩ̓̓Rg[̒l̏ꍇ
  //̋󕶎͐Ƃ݂ȂGetPropertiesōĎ擾̂ŋł悢
  //ߑOߌ̋̕󔒂͋Ȃ
  end else if FlagAmpm   or
              FlagYear   or
              FlagMonth  or
              FlagDay    or
              FlagHour   or
              FlagMinute or
              FlagSecond then begin
    FIsEmpty := False;
    //󔒓͂ĂĂ1ł͂ꍇ̓G[
    //󔒋Ƃ͑S͗󔒂̏ꍇӖ
    //ŉE[̃Rg[`FbN
    if FlagSecond then begin
      AWinControl := FSecondEdit;
      Include(FErrorKinds, derSecondEmpty);
    end;
    if FlagMinute then begin
      AWinControl := FMinuteEdit;
      Include(FErrorKinds, derMinuteEmpty);
    end;
    if FlagHour then begin
      AWinControl := FHourEdit;
      Include(FErrorKinds, derHourEmpty);
    end;
    if FlagAmpm then begin
      AWinControl := FAmpmCombo;
      Include(FErrorKinds, derAmpmEmpty);
    end;
    if FlagDay then begin
      AWinControl := FDayEdit;
      Include(FErrorKinds, derDayEmpty);
    end;
    if FlagMonth then begin
      AWinControl := FMonthEdit;
      Include(FErrorKinds, derMonthEmpty);
    end;
    if FlagYear then begin
      AWinControl := FYearEdit;
      Include(FErrorKinds, derYearEmpty);
    end;
    if FlagGengo then begin
      AWinControl := FGengoCombo;
      Include(FErrorKinds, derYearEmpty);
    end;
    ShowErrorDialog(ErrorS6, AWinControl);
  //SĂ̗܂͌IXgȊO͂Ăꍇ
  end else begin
    FIsEmpty := False;
    //O猳w肵ꍇlĕɊYItemIndex𒲍
    //O̎wItemIndexŎw肷邪,EraNames,EraYearOffsets̔zύX
    //ꍇłȂȉ̃R[hőΉł
    //(EraNames,EraYearOffsetsSysUtilsŒ`Ă)
    //͕͂̕KR{{bNX̃XgIȂ΂ȂȂ
    AIndex := 0;
    if FEditGengo then begin
      for i := 0 to FGengoCombo. Items.Count - 1 do begin
        if FGengoCombo.Items[i] = StrGengo then begin
          AIndex := i;
          break;
        end;
      end;
    end;
    //IXg󔒂̎͐NƂ݂Ȃ
    if AIndex = 0 then begin
      dYear := StrToIntDef(StrYear, 0);
      //͂̎ɔN̓͌2(FYeardigit=2)̎͐̉2Ƃ݂Ȃ
      if FYeardigit = yddigit2 then begin
        dYear := dYear + (StrToInt(FormatDateTime('yyyy', Now)) div 100) * 100;
      end;
    end else begin
      dYear := EraYearOffsets[AIndex] - 1 + StrToIntDef(StrYear, 0);
    end;
    //NȊO̊eRg[̕𐔒lɕϊ
    dMonth  := StrToIntDef(StrMonth,  1);
    dDay    := StrToIntDef(StrDay,    1);
    dHour   := StrToIntDef(StrHour,   0);
    dMinute := StrToIntDef(StrMinute, 0);
    dSecond := StrToIntDef(StrSecond, 0);
  end;

  //܂̃`FbN
  if (FHourEdit.Visible) then begin
    if FAmpmCombo.Visible then AIndex := FAmpmCombo.ItemIndex
                          else AIndex := -1;
    //ԒlATime0ȏ1̒lD@vpeB擾(FHour)͌ߌ͌ߌ
    //ŕԂ̂ł邪CEncodeTimeŃG[o邽߂Ɉx24Ԓl
    //ɕϊ
    if (AIndex = 0) or (AIndex = 1) then begin
      if (dHour > 12) or ((dHour = 12) and ((dMinute >= 0.0) or (dSecond>= 0.0))) then begin
        FErrorKinds := [derTimeError];
        ShowErrorDialog(ErrorS9, FHourEdit);
      end;
    end else begin
      if (dHour > 24) or ((dHour = 24) and ((dMinute >= 0.0) or (dSecond >= 0.0))) then begin
        FErrorKinds := [derTimeError];
        ShowErrorDialog(ErrorS10, FHourEdit);
      end;
    end;
    if (dMinute > 59) or (dSecond > 59) then begin
      FErrorKinds := [derTimeError];
      ShowErrorDialog(ErrorS9, FMinuteEdit);
    end else begin
      if AIndex = 1 then dHour := dHour + 12;
      try
        dMiri  := 0;
        ATime  := EncodeTime(dHour, dMinute, dSecond, dMiri);
        Result := False;
      except
        FErrorKinds := [derTimeError];
        if FEditAmpm then ShowErrorDialog(ErrorS4, FAmpmCombo)
                     else ShowErrorDialog(ErrorS4, FHourEdit);
      end;
    end;
  end;

  //tɕϊăG[ȂȂ炻ꂪt
  //1873.1.1(6N11)O̓G[
  //2088N(99N)ȏŘa\̎G[
  //G[łȂGetPropertiesŊevpeBĎ擾
  if (FYearEdit.Visible) then begin
    try
      ADate := EncodeDate(dYear,dMonth,dDay);
      if (dYear<1873) then begin
        FErrorKinds := [derBeforeBaseDate];
        ShowErrorDialog(ErrorS2,FYearEdit);
      end else if (dYear>=2088) and (FGengo) then begin
        FErrorKinds := [derChangeGengo];
        ShowErrorDialog(ErrorS7,FYearEdit);
      end else begin
        Result := False;
      end;
    except
      FErrorKinds := [derDateError];
      ShowErrorDialog(ErrorS11,FYearEdit);
    end;
  end;

  //G[łȂGetPropertiesŊevpeBĎ擾
  if not Result then begin
    try
      FDateTime := Trunc(ADate)+Frac(ATime);
      FDate     := FDateTime;
      GetProperties;
    except
      FErrorKinds := [derDateTimeError];
      ShowErrorDialog(ErrorS8,nil);
    end;
  end;
end;

//=============================================================================
//  G[_CAO̕\
//
//  vpeB擾̍,G[ɂ̃\bhďo
//  G[ƃTCgÔ,ȉ̗lɏ邱Ƃ
//   .̎ErrorDialogTrueȂ,̌x_CAO\.
//
//  try
//    //擾vpeBȂ牽ł`FbN\
//    plDateEdit1.DateTime;
//  except
//    //_CAO\Ȃǂ̃G[̏
//    //ErrorKindsŃG[̓em邱Ƃ\
//  end;
//=============================================================================
procedure TplDateEdit.ShowErrorDialog(ERStr: String; AWinControl: TWinControl);
begin
  if FDisplayError then begin
    Application.MessageBox(PChar(ERStr), PChar(FDialogCaption), MB_OK + MB_ICONINFORMATION);
  end;
  SetControlFocus(AWinControl);
  Abort;
end;

//=============================================================================
//  FDate(t̂)̒levpeB擾ĊeRg[ւ̔N
//  ĕ\D
//  DecodeFDate=0̂ƂN0ƂȂĂ܂̂ŎgpȂ
//  ȁꍇlčČvZ(a70NXXXXƓ͂ꍇ̊YNɒ
//  ).
//
//  ̊֐́CDateTimevpeBɒlZbgCe̓Rg[ɒl
//  ̕Zbg邽߂ɌďoĂD
//
//  l: FBaseDate := StrToDateTime('1873/01/01');
//=============================================================================
function TplDateEdit.GetProperties : Boolean;
var
  i : Integer;
begin
  Result := True;

  //1873.1.1(6N11)O͉Ȃ
  if FYearEdit.Visible then begin
    if FDateTime >= FBaseDate then begin
      FIsEmpty := False;
      try
        FYear      := StrToInt(FormatDateTime ('yyyy', FDateTime)); //N
        FMonth     := StrToInt(FormatDateTime ('m',    FDateTime)); //
        FDay       := StrToInt(FormatDateTime ('d',    FDateTime)); //
        FGengoStr  := FormatDateTime          ('ggg',  FDateTime);  //
        FGengoYear := StrToInt(FormatDateTime ('e',    FDateTime)); //N
        //\̎w͌Ď擾(aɂȂ邩mȂ
        //FGengoStrƓItemIndex̕R{ɕ\
        if FGengo then begin
          FGengoCombo.Text := FGengoStr;
          for i := 1 to MaxEraCount do begin
            if EraNames[i] = FGengoStr then begin
              FGengoCombo.ItemIndex := i;
              break;
            end;
          end;
          FYearEdit.Text := IntToStr(FGengoYear);
        //\w̎
        end else begin
          //ItemIndex0Œ
          //ĨR{łĂŕ\
          //\2̏ꍇ(FYeardigit=yddigit2)͉2̂ݕ\
          FGengoCombo.ItemIndex := 0;
          FYearStr := IntToStr(FYear);
          if FYeardigit = yddigit2 then begin
            FYearEdit.Text := Copy(FYearStr, Length(FYearStr) - 1, Length(FYearStr));
          end else begin
            FYearEdit.Text := FYearStr;
          end;
        end;
        FMonthEdit.Text := IntToStr(FMonth);
        FDayEdit.Text   := IntToStr(FDay);
        FYearStr        := IntToStr(FYear);
        FMonthStr       := IntToStr(FMonth);
        FDayStr         := IntToStr(FDay);
        FGengoYearStr   := IntToStr(FGengoYear);
      except
        Result := False;
      end;
    end else begin
      Result := False;
    end;
  end;

  //DecodeŊel擾Ă悢t̃̕R[hɍ
  //ߑOߌ̑IR{\Ăꍇ͌ߑOߌ̎Ŏ擾
  if (FHourEdit.Visible) and (Frac(FDateTime) > 0) then begin
    FIsEmpty := False;
    try
      FAmpmStr := '';
      FHour    := StrToInt(FormatDateTime ('hh', FDateTime)); //24ԕ\
      if FEditAmpm then begin
        if FHour < 12 then FAmpmCombo.ItemIndex := 0 else FAmpmCombo.ItemIndex := 1;
        if (FAmpmCombo.ItemIndex = 1) then FHour := FHOur - 12;
        FAmpmStr := FAmpmCombo.Text;
      end;
      FMinute          := StrToInt(FormatDateTime ('nn', FDateTime));
      FSecond          := StrToInt(FormatDateTime ('ss', FDateTime));
      FHourStr         := IntToStr(FHour);
      FMinuteStr       := IntToStr(FMinute);
      FSecondStr       := IntToStr(FSecond);
      FHourEdit.Text   := FHourStr;
      FMinuteEdit.Text := FMinuteStr;
      FSecondEdit.Text := FSecondStr;
    except
      Result := False;
    end;
  end;
end;

//=============================================================================
//  N,,̒l()擾
//  0: ̕
//  1: ̔N
//  2: N
//  3: 
//  4: 
//  5: 
//  6: 
//  7: b
//=============================================================================
function TplDateEdit.GetDateStr(Index: Integer): String;
begin
  Result := '';

  if CheckDateError = False then begin
    case Index of
      0: Result := FGengoStr;
      1: Result := FGengoYearStr;
      2: Result := FYearStr;
      3: Result := FMonthStr;
      4: Result := FDayStr;
      5: Result := FAmpmStr;
      6: Result := FHourStr;
      7: Result := FMinuteStr;
      8: Result := FSecondStr;
    end;
  end;
end;

//=============================================================================
//  N,,̒l(l)擾
//  1: ̔N
//  2: N
//  3: 
//  4: 
//  5: 
//  6: 
//  7: b
//=============================================================================
function TplDateEdit.GetDateInt(Index: Integer): Integer;
begin
  Result := 0;

  if CheckDateError = False then begin
    case Index of
      1: Result := FGengoYear;
      2: Result := FYear;
      3: Result := FMonth;
      4: Result := FDay;
      5: Result := FHour;
      6: Result := FMinute;
      7: Result := FSecond;
    end;
  end;
end;

//=============================================================================
//  e͒l󔒂ǂo
//
//  g̗
//
//  if plDateEdit1.IsEmpty then begin
//    //󔒂̎̏
//  end else bggin
//    //͂t擾ď
//    MyDate := plDateEdit1.Date;
//  end;
//=============================================================================
function TplDateEdit.GetIsEmpty: Boolean;
begin
  Result := False;

  if (FGengoCombo.Text = '') and
     (FAmpmCombo .Text = '') and
     (FYearEdit  .Text = '') and
     (FMonthEdit .Text = '') and
     (FDayEdit   .Text = '') and
     (FHourEdit  .Text = '') and
     (FMinuteEdit.Text = '') and
     (FSecondEdit.Text = '') then Result := True;
end;

//=============================================================================
//  FontvpeBύXꂽ̃bZ[W̏
//  eRg[̃TCYs
//=============================================================================
procedure TplDateEdit.CMFontChanged(var Message: TWMNoParams);
begin
  inherited;
  SetControlResizePosition(False);
end;

//=============================================================================
//  TabStopvpeB̐ݒ
//  TabStopTrueɂ,[Tab]ړōŏ̃Rg[ɃtH[JXړ
//  Ȃ.܂[Shift]+[Tab]̈ړȂ.
//=============================================================================
procedure TplDateEdit.SetControlTabStop(const Value: Boolean);
begin
  FTabStop := Value;
  inherited TabStop   := False;
    
  FGengoCombo.TabStop := FTabStop;
  FYearEdit.TabStop   := FTabStop;
  FMonthEdit.TabStop  := FTabStop;
  FDayEdit.TabStop    := FTabStop;
  FAmpmCombo.TabStop  := FTabStop;
  FHourEdit.TabStop   := FTabStop;
  FMinuteEdit.TabStop := FTabStop;
  FSecondEdit.TabStop := FTabStop;
end;

//=============================================================================
//  ̃R|̓TCYsƂ
//=============================================================================
function TplDateEdit.CanResize(var NewWidth, NewHeight: Integer): Boolean;
begin
  Result := False;
  if (FGengoCombo = nil) or (FAmpmCombo = nil) then exit;
  if (csReading in ComponentState) then exit;
  if fgResize = False then begin
    Result := False;
  end else begin
    Result := True;
  end;
end;

//=============================================================================
//  ̃R|SetFocus\Ă鍶[̃Rg[ɃtH[JXړ
//
//  AWinControl  ړ̃Rg[
//=============================================================================
procedure TplDateEdit.SetControlFocus(AWinControl: TWinControl);
begin
  if Enabled and Visible then begin
    if AWinControl = nil then begin
      if (FGengoCombo.Visible) and (FGengoCombo.Enabled) then begin
        FGengoCombo.SetFocus;
      end else
      if (FYearEdit.Visible) and (FYearEdit.Enabled) then begin
        FYearEdit.SetFocus;
      end else
      if (FAmpmCombo.Visible) and (FAmpmCombo.Enabled) then begin
        FAmpmCombo.SetFocus;
      end else begin
        if (FHourEdit.Visible) and (FHourEdit.Enabled) then begin
          FHourEdit.SetFocus;
        end;
      end;
    end else begin
      if TWinControl(AWinControl).Visible and TWinControl(AWinControl).Enabled then begin
        AWinControl.SetFocus;
      end;
    end;
    FFocused := True;
  end;
end;

//=============================================================================
//  R|EnabledvpeBύXꂽɃR|gɑĂ
//  Cm_EnabledChangedbZ[W̏D
//  Enabled=True,Enabled=False(Disabled)ɉē͗pRg[̔wiFƕ
//  FύX.
//=============================================================================
procedure TplDateEdit.CMEnabledChanged(var Message: TWMNoParams);
begin
  inherited;
  SetEditColor;
end;

//=============================================================================
//  ColorvpeBύXƂȂ̏
//  ColorvpeB͌p̂ł͂Ȃ,ʂɒ`Ă.
//=============================================================================
procedure TplDateEdit.SetControlColor(const Value: TColor);
begin
  if FColor <> Value then begin
    FColor := Value;
    SetEditColor;
  end;
end;

//=============================================================================
//  EnabledvpeBɂăRg[̔wiFς
//=============================================================================
procedure TplDateEdit.SetEditColor;
begin
  if Enabled = False then begin
    FGengoCombo.Enabled    := False;
    FAmpmCombo.Enabled     := False;
    FGengoCombo.Color      := FDisableColor;
    FYearEdit.Color        := FDisableColor;
    FMonthEdit.Color       := FDisableColor;
    FDayEdit.Color         := FDisableColor;
    FHourEdit.Color        := FDisableColor;
    FMinuteEdit.Color      := FDisableColor;
    FSecondEdit.Color      := FDisableColor;

    FGengoCombo.Font.Color := FDisableFontColor;
    FYearEdit.Font.Color   := FDisableFontColor;
    FMonthEdit.Font.Color  := FDisableFontColor;
    FDayEdit.Font.Color    := FDisableFontColor;
    FHourEdit.Font.Color   := FDisableFontColor;
    FMinuteEdit.Font.Color := FDisableFontColor;
    FSecondEdit.Font.Color := FDisableFontColor;
  end else begin
    FGengoCombo.Enabled    := True;
    FGengoCombo.Color      := FColor;
    FYearEdit.Color        := FColor;
    FMonthEdit.Color       := FColor;
    FDayEdit.Color         := FColor;
    FHourEdit.Color        := FColor;
    FMinuteEdit.Color      := FColor;
    FSecondEdit.Color      := FColor;

    FGengoCombo.Font.Color := Font.Color;
    FYearEdit.Font.Color   := Font.Color;
    FMonthEdit.Font.Color  := Font.Color;
    FDayEdit.Font.Color    := Font.Color;
    FDayEdit.Font.Color    := Font.Color;
    FHourEdit.Font.Color   := Font.Color;
    FMinuteEdit.Font.Color := Font.Color;
    FSecondEdit.Font.Color := Font.Color;
  end;
end;

//=============================================================================
//  EnabelvpeBFalse̎̓̓Rg[̔wiF̐ݒ
//  Ver1.1Œǉ
//=============================================================================
procedure TplDateEdit.SetDisableColor(const Value: TColor);
begin
  if FDisableColor <> Value then begin
    FDisableColor := Value;
    SetEditColor;
  end;
end;

//=============================================================================
//  EnabledvpeBFalse̎̓̓Rg[̐̕Fݒ
//  Ver1.1Œǉ
//=============================================================================
procedure TplDateEdit.SetDisableFontColor(const Value: TColor);
begin
  if FDisableFontColor <> Value then begin
    FDisableFontColor := Value;
    SetEditColor;
  end;
end;

//=============================================================================
//  tH[JX̏
//  R|gTabStopFalseɂĂ̂ŌIN̓Rg[ɃtH
//  [JX.
//=============================================================================
procedure TplDateEdit.WMSetFocus(var Message: TWMSetFocus);
begin
  inherited;
  SetControlFocus(nil);
end;

//=============================================================================
//  Rg[ActiveɂȂeLXgIԂ
//=============================================================================
procedure TplDateEdit.EditEnter(Sender: TObject);
begin
  fgTabStop := FTabStop;

  if fgTabStop = False then begin
    FGengoCombo.TabStop := True;
    FYearEdit.TabStop   := True;
    FMonthEdit.TabStop  := True;
    FDayEdit.TabStop    := True;
    FAmpmCombo.TabStop  := True;
    FHourEdit.TabStop   := True;
    FMinuteEdit.TabStop := True;
    FSecondEdit.TabStop := True;
  end;

  if Sender is TComboBox then begin
    if TComboBox(Sender).Visible then begin
      TComboBox(Sender).SetFocus;
      TComboBox(Sender).Color := FFocusedColor;
      if FAutoSelect then TComboBox(Sender).SelectAll;
    end;
  end;
  if Sender is TplDateEditEdit then begin
    TplDateEditEdit(Sender).SetFocus;
    TplDateEditEdit(Sender).Color := FFocusedColor;
    if FAutoSelect then begin
      TplDateEditEdit(Sender).SelectAll;
    end else begin
      TplDateEditEdit(Sender).SelStart := 0;
    end;
  end;
  FFocused := True;
end;

//=============================================================================
//  Rg[ActivełȂȂwiFɖ߂
//=============================================================================
procedure TplDateEdit.EditExit(Sender: TObject);
begin
  if TComboBox(Sender).Visible then TComboBox(Sender).Color := FColor;
  TplDateEditEdit(Sender).Color := FColor;
end;

//=============================================================================
//  ̃R|ActivełȂȂꍇ
//  ̌oƂĂWM_KILLFOCUŜł邪,̃R|ł,tH[JX
//  ړĂɍ[̃Rg[ɃtH[JXړĂ邽,̎
//  KillFocsuĂ܂.
//=============================================================================
procedure TplDateEdit.DoExit;
begin
  inherited;

  //Rg[̕IԂ̏ꍇlĉĂ
  FYearEdit.SelStart;
  FMonthEdit.SelStart;
  FDayEdit.SelStart;
  FHourEdit.SelStart;
  FMinuteEdit.SelStart;
  FSecondEdit.SelStart;
  if FExitCheck then CheckDateError;
  SetControlTabStop(fgTabStop);
  FFocused := False;
end;

//=============================================================================
//  ̃Xg\wiFύX
//  R{{bNXOnDropDownCxg
//  WindowsXPƂOOSƓقړɂ邽߂
//=============================================================================
procedure TplDateEdit.GengoDropDown(Sender: TObject);
begin
    TComboBox(Sender).Color := FFocusedColor;
end;

//=============================================================================
//  IR{{bNXOnDrawItemCxgp
//  FFcosedColorȊO̎́CtH[JX̓_`悵Ȃ
//  AutoSelect=TruȅꍇłR{{cNX͑IԂɂȂ(폜ȊO͕ҏWs
//  Ȃ̂)
//  l
//  R{{bNXEditɉ͂Ȃ́CDrawItem͔Ȃ
//=============================================================================
procedure TplDateEdit.GengoDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  with TComboBox(Control) do begin
    if (FAutoSelect = False) and (FFocusedColor <> clWhite) then begin
        //I
        if odSelected in State then begin
          //Edit
          if odComboBoxEdit in State then begin
            Canvas.Brush.Style := bsClear;
          end else begin
            Canvas.Brush.Color := FFocusedColor;
          end;
        end else
        if odComboBoxEdit in State then begin
          Canvas.Brush.Style := bsClear;
        end else begin
          Canvas.Brush.Color := FColor;
        end;
        Canvas.Font.Assign(Font);
    end;
    Canvas.FillRect(Rect);
    Rect.Left  := Rect.Left+2;
    DrawText(Canvas.Handle,
             PChar(Items[Index]),
             -1,
             Rect,
             DT_SINGLELINE or DT_VCENTER or DT_LEFT);
  end;
end;

//=============================================================================
//  [TAB]L[OnKeyDownCxgŏ\ɂ
//  O炱̃R|gpۂɕKv
//  ꂪȂƁCÕvO[Enter],[Tab]Ȃǂ̓L[ołȂ
//=============================================================================
procedure TplDateEdit.CMWantSpecialKey(var Msg: TMessage);
begin
  if Msg.WParam = VK_TAB then Msg.Result := 1;
end;

//=============================================================================
//  L[͏
//  [Enter]KeyDownŏ̂ŉȂ
//  p͓͂łȂ. #8[BackSpace]. #27[Escape]
//=============================================================================
procedure TplDateEdit.EditKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Assigned(FOnKeyPress) then FOnKeyPress(Sender, Key);
  if Key = #13 then begin
    Key := #0;
  end else begin
    if (Sender is TplDateEditEdit) then begin
      if ((Key >= '0') and (Key <= '9')) or (Key = #8) or (Key = #27) then begin
        inherited KeyPress(Key);
      end else begin
        Key := #0;
      end;
    end else if (Sender is TComboBox) then begin
      if (Key = #8) or (Key = #27) then begin
        inherited KeyPress(Key);
      end else begin
        Key := #0;
      end;
    end else begin
      Key := #0;
    end;
  end;
end;

{$IFDEF CONDITIONALEXPRESSIONS}
{$IF RTLVersion >= 24.0}
function TplDateEdit.FormatDateTime(const Format: string;
  DateTime: TDateTime): string;
begin
  Result := System.SysUtils.FormatDateTime(Format, DateTime, FFormatSettings);
end;
{$IFEND}
{$ENDIF}

//=============================================================================
//  eL[̏
//  [DELETE]Ō̕NA\ɂ(Ver1.1)
//
//  [Tab]͂̃R|gpAvCMDialogKey`Ƌ@\ȂȂ
//  ܂.
//
//  ܂܂ł̃R[h
//  keybd_event( VK_TAB, MapVirtualKey(VK_TAB, 0), 0 , 0 );
//  keybd_event( VK_TAB, MapVirtualKey(VK_TAB, 0), KEYEVENTF_KEYUP , 0 );
//  ̃R[h[Tab],[Shift]+[Tab],[Enter],[Shift]+[Enter]̑SĂ̏s
//  ĕ֗ł͂̂...
//
//  VR[hFindNextControlgp
//  ꂾ[Tab]ołȂ̂,VCM_WantSpeialKeyCxgǉ
//  if Key=VK_TAB (Ver1.2)
//  Ver1.2ł͂̑,OnKeyPress,OnKeyDownCxǧJ,FocusedvpeB
//  ǉ.
//=============================================================================
procedure TplDateEdit.EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Assigned(FOnKeyDown) then FOnKeyDown(Sender, Key, Shift);

  //R{{bNX[Enter]őI
  if Key = VK_RETURN then begin
    if TComboBox(Sender).Visible then TComboBox(Sender).DroppedDown := False;
    //̃^uRg[Ɉړ
    if FEnterNext then begin
      if (ssShift in Shift) then begin
        keybd_event( VK_TAB,   MapVirtualKey(VK_TAB, 0),   0, 0 );
        keybd_event( VK_SHIFT, MapVirtualKey(VK_SHIFT, 0), 0, 0 );
        keybd_event( VK_TAB,   MapVirtualKey(VK_TAB, 0),   KEYEVENTF_KEYUP , 0 );
        keybd_event( VK_SHIFT, MapVirtualKey(VK_SHIFT, 0), KEYEVENTF_KEYUP , 0 );
      end else begin
        keybd_event( VK_TAB, MapVirtualKey(VK_TAB, 0), 0 , 0 );
        keybd_event( VK_TAB, MapVirtualKey(VK_TAB, 0), KEYEVENTF_KEYUP , 0 );
      end;
    end;
  end else if Key = VK_TAB then begin
    if (ssShift in Shift) then begin
      TWinControl(FindNextControl(TWinControl(Sender), False, True, True)).Setfocus;
    end else begin
      TWinControl(FindNextControl(TWinControl(Sender), True, True, True)).Setfocus;
    end;
  //ŃR{̃hbv_EXg\
  end else if Key = VK_DOWN then begin
    if FDropDownKey then begin
      if TComboBox(Sender).Visible then begin
        if (TComboBox(Sender).DroppedDown = False) then begin
          Key := 0;
          TComboBox(Sender).DroppedDown := True;
        end;
      end;
    end;
  end else if Key = VK_DELETE then begin
    if Sender is TComboBox then begin
      if TComboBox(Sender).Text <> '' then begin
        TComboBox(Sender).ItemIndex := -1;
        if Assigned(FOnChange) then FOnChange(Sender);
      end else begin
        TComboBox(Sender).ItemIndex := -1;
      end;
    end;
  end;

  inherited;
end;

//=============================================================================
//   e̓Rg[OnChangeCxgnh
//=============================================================================
procedure TplDateEdit.EditChange(Sender: TObject);
begin
  if Assigned(FOnChange) then FOnChange(Sender);
end;

//=============================================================================
//  e̓Rg[OnClickCxgnh
//  OnEnter̃Cxg`ƂOnClick͔Ȃ
//  (̃R|[lgƓ.m܂ł)
//=============================================================================
procedure TplDateEdit.EditClick(Sender: TObject);
begin
  if Assigned(FOnClick) then FOnClick(Sender);
end;

//=============================================================================
//  ŇvZ
//
//  ʓIɉXN,aɒBɉZ
//  (55܂̐l͎̔N55̌ߑO01Z.ߑO0͑Ǒߌ12
//  )D
//
//  Ƃ낪,e@ŁuNɒBv̉߂Ă.
//
//  @IɔNvZ̎d߂Ă̂́u@vƁuNvZɊւ@v.
//   @ł͊ԂvẐ,
//  (1),NȂǂł̊Ԃ߂ꍇ͋NZ͎ZȂ
//  (2)NZ̑OŊԂ𖞗Ƃ
//  N͗OƂāuo̓肱NZvƂȂĂ.
//
//  Ⴆ,wZ@ł,41܂̐l1wNɍŝ́uq̖Z΂ɒB
//  ̗Ȍɂŏ̊wN̏߂vƒ߂Ă(@̕
//  ͓!!).܂,41܂̎q,331̌ߌ121No߂Ė1
//  ˂ƂȂ邽,̊wNƂȂ.
//
//  ܂,EI@ł,I͖20Έȏ̐lɔF߂Ă.729[
//  ̏ꍇ,u20NɒBIƂv,20NɒB܂ށv
//  u20NɒBđI擾̎n߂vƂ݂Ȃ,20΂ɂ
//  ߌ12܂߂̓S擾̓ƂĂ.܂,u[729
//  ̌ߌ12ɖ20΂ɂȂ730܂̐l܂Łv([_ł͂܂19΂̐l
//  ܂܂)ƂȂ.
//
//  N@ł,uavƂtł͂Ȃu41ɐ܂ꂽ҂65΂ɂ
//  ̂331vłvƂĂ.
//  ܂,@Iɂ͒ȃOɖNɒBƂ݂Ȃ
//
//  Vlی@ł,70΂̒ȃ錎̗(A1a̎҂͂̌)
//  ̓KpƂȂĂ.
//
//  ,̃\bhł͂ǂɂΉ\Ȃ悤,AgeType̒lɂ
//  vZNƌύX\Ȃ悤ɂ.
//
//  AgeType=0 ݂̔N(ԈʂłN)
//  AgeType=1 ݂܂ł̊(ȃOɉ)
//=============================================================================
function TplDateEdit.GetAge(Date1, Date2: TDateTime; AgeType: Integer;
  var gAge, gMonth: Integer): Boolean;
var
  Year1  : WORD;
  Month1 : WORD;
  Day1   : WORD;
  Year2  : WORD;
  Month2 : WORD;
  Day2   : WORD;
begin
  Result := True;
  try
    DecodeDate (Date1, Year1, Month1, Day1);
    DecodeDate (Date2, Year2, Month2, Day2);
    //AgeType=0  ʏ̔N
    if (AgeType = 0)  then begin
      if (Day1 > Day2) then Dec(Month2);
    //AgeType=1  oߔN
    end else begin
      if (Month2 = 12) then begin
        if (Day2 = 31)then begin
          Inc(Year2);
          Month2 := 1;
          Day2   := 0;
        end;
      end else if Date2 = EncodeDate(Year2, Month2 + 1, 1) - 1 then begin
        Inc(Month2);
        Day2 := 0 ;
      end;
      if Day1 > (Day2 + 1) then Dec(Month2);
    end;
    gMonth := Month2 - Month1;
    gAge := Year2 - Year1;
    if (gMonth >= -12) and (gMonth <= -1) then begin
      Dec(gAge);
      gMonth := 12 + gMonth;
    end;
    if gAge < 0 then begin
      Result := False;
      gAge   := 0;
      gMonth := 0;
    end;
  except
    Result := False;
    gAge   := 0;
    gMonth := 0;
  end;
end;

//=============================================================================
//  a̓t擾֐
//  a 1 NuNvɁC1  1 uvŎ擾
//
//  uNv̕\LRŌ΁CN̍ŏ̓ł 1  1 ́uvł
//=============================================================================
function TplDateEdit.ToGannenGanjitu(ADate: TDateTime; ToGanjitu: Boolean;
  NeedSpace:Boolean): string;
var
  LYear     : string;
  LMonthDay : string;
begin
  if FGengoYear = 1 then begin
    LYear := FGengoStr + ' N';
  end else begin
    LYear := FGengoStr + ' ' + FGengoYearStr + ' N';
  end;

  if ToGanjitu and (FMonth = 1) and (FDay = 1) then begin
    LMonthDay := ''
  end else begin
    LMonthDay := FMonthStr + '  ' + FDayStr + ' ';
  end;

  Result := LYear + ' ' + LMonthDay;
  if not NeedSpace then begin
    Result := StringReplace(Result, ' ', '', [rfReplaceAll]);
  end;
end;


{ TplDBDateEdit }

//=============================================================================
//  ȉ̃R[hTAKɍ쐬ĒR[hقڂ̂܂ܗp.
//  begin`end; ̊Ԃ̃R[h̃Cfg
//  if then begin else ̃X^C
//  Mr.XRAYX^CɕύX
//  ̃R[h̒ǉɂ͂Ԗ.R|[lgɃf[^x[XΉ
//  ǉ邩,ʂ̃R|[lgɂ邩.,ʃR|[lgƂ邱Ƃ
//  .
//-----------------------------------------------------------------------------
//  f[^x[XΉR|[lg
//=============================================================================
constructor TplDBDateEdit.Create(AOwner: TComponent);
begin
  inherited;
    
  FDataLink := TFieldDataLink.Create;
  FDataLink.Control := Self;
  FDataLink.OnDataChange := DataChange;
  FDataLink.OnUpdateData := UpdateData;
  IsEdit := False;
end;

//=============================================================================
//  R|[lg̔j
//=============================================================================
destructor TplDBDateEdit.Destroy;
begin
  FreeAndNil(FDataLink);
  inherited;
end;
//=============================================================================
//  f[^\[Xj̏
//=============================================================================
procedure TplDBDateEdit.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  if (Operation = opRemove) and (FDataLink <> nil) and
     (AComponent = DataSource) then begin
     FDataLink.DataSource := nil;
  end;
end;

//=============================================================================
//  f[^\[X̐ݒ
//=============================================================================
procedure TplDBDateEdit.SetDataSource(const Value: TDataSource);
begin
  if FDataLink.DataSource <> Value then begin
    FDataLink.DataSource := Value;
    //f[^\[X̔jʒmo^
    if Value <> nil then Value.FreeNotification(Self);
  end;
end;

//=============================================================================
//  f[^\[X̎擾
//=============================================================================
function TplDBDateEdit.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end;

//=============================================================================
//  f[^tB[h̐ݒ
//=============================================================================
procedure TplDBDateEdit.SetDataField(const Value: string);
begin
  FDataLink.FieldName := Value;
end;

//=============================================================================
//  f[^tB[h̎擾
//=============================================================================
function TplDBDateEdit.GetDataField: string;
begin
  Result := FDataLink.FieldName;
end;

//=============================================================================
//  ReadOnlyvpeB̃Zbg
//  f[^N ReadOnlyvpeBɏނ
//=============================================================================
procedure TplDBDateEdit.SetReadOnly(const Value: Boolean);
begin
  FDataLink.ReadOnly := Value;
end;

//=============================================================================
//  ReadOnlyvpeB̎擾
//  f[^N ReadOnlyvpeBǂނ
//=============================================================================
function TplDBDateEdit.GetReadOnly: Boolean;
begin
  Result := FDataLink.ReadOnly;
end;

//=============================================================================
//  OnDataChange Cxg̏
//  R|DateTimevpeBltB[h̒l擾
//=============================================================================
procedure TplDBDateEdit.DataChange(Sender: TObject);
var
  AField : TField;
begin
  //ݒ͓Ǎ܂Ȃ
  if IsEdit then exit;

  AField := FindField;
  if Assigned(AField) then begin
    if AField.IsNull then begin
      SetEditEmpty;
    end else begin
      DateTime := AField.AsDateTime;
    end;
  end;
end;

//=============================================================================
//  tH[JXtB[hɃf[^
//  DBGridȂǂŃZړPostĂ̂Ɠ
//=============================================================================
procedure TplDBDateEdit.DoExit;
var
  AField : TField;
begin
  inherited;

  AField := FindField;
  if Assigned(AField) then begin
    if DateTime <> AField.AsDateTime then begin
      //Ǎ݂֎~tO
      IsEdit := True;
      FDataLink.DataSet.Edit;
      if CanEmpty and IsEmpty then begin
        AField.Value := null;
      end else begin
        AField.AsDateTime := DateTime;
      end;
      //ޏI
      IsEdit := False;
      //f[^XV
      FDataLink.Reset;
    end;
  end;
end;

//=============================================================================
//  mɂ邽߂ɃtB[h
//  Ŏ擾tB[hɃANZX
//=============================================================================
function TplDBDateEdit.FindField: TField;
begin
  Result := nil;
  if (FDataLink.FieldName <> '') and Assigned(FDataLink.DataSet) then begin
    Result := FDataLink.DataSet.FindField(FDataLink.FieldName);
  end;
end;

//=============================================================================
//  eRg[OnKeyPressCxg̏
//  ReadOnly=True̎̓L[͂tȂ
//  [Tab][Entr][Shift]ȂOnKeyDownŏL[͎t
//=============================================================================
procedure TplDBDateEdit.EditKeyPress(Sender: TObject; var Key: Char);
begin
  if not FDataLink.CanModify then Key := #0;
  inherited;
end;

//=============================================================================
//  eRg[OnKeyDownCxg̏
//=============================================================================
procedure TplDBDateEdit.EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //ESCL[ꂽtB[hl̕ҏWLZ
  if Key = VK_ESCAPE then begin
    FDatalink.Reset;
    Key := 0;
  end;
  if not FDataLink.CanModify then Key := 0;

  inherited;
end;

//=============================================================================
//  ̓Rg[̓eɕύXꍇ(OnChageCxg)ꍇ),
//  DataSetEdit[hȂUpdateDateCxgďoĕύXR[hɔf.
//  ꂪȂ,tH[JXR[h̍XVłȂ
//  (̃f[^x[XΉRg[Ɠ삪Ă܂)
//=============================================================================
procedure TplDBDateEdit.EditChange(Sender: TObject);
begin
  //ReadOnly=True̎̓R{{bNXɂI͖ɂ
  //N̓͂̓L[͂̂̂𖳌ɂĂ
  if FDataLink.Field = nil then begin
    SetEditEmpty;
  end else if not FDataLink.CanModify then begin
    if Sender is TComboBox then begin
      FDataLink.Reset;
    end;
  end else begin
    inherited;
    if FDataLink.Edit then FDataLink.Modified;
  end;
end;

//=============================================================================
//  OnUpdateCxg̃nh
//=============================================================================
procedure TplDBDateEdit.UpdateData(Sender: TObject);
begin
  if CanEmpty and IsEmpty then begin
    FDataLink.Field.Value := null;
  end else begin
    FDataLink.Field.AsDateTime := DateTime;
  end;
end;

//=============================================================================
//   R|[lgo^
//=============================================================================
procedure Register;
begin
  RegisterComponents('plXRAY', [TplDateEdit]);
  RegisterComponents('plXRAY', [TplDBDateEdit]);
end;

//=============================================================================
//  R[hI
//=============================================================================
end.
